/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     IF = 267,
     FI = 268,
     ELSE = 269,
     ELIF = 270,
     ON = 271,
     HOST = 272,
     FOR = 273,
     FROM = 274,
     AS = 275,
     DO = 276,
     DONE = 277,
     POLL = 278,
     MATCHES = 279,
     FNMATCHES = 280,
     MXMATCHES = 281,
     MXFNMATCHES = 282,
     WHEN = 283,
     NEXT = 284,
     SET = 285,
     CATCH = 286,
     KW_ECHO = 287,
     RETURNS = 288,
     RETURN = 289,
     FUNC = 290,
     SWITCH = 291,
     CASE = 292,
     DEFAULT = 293,
     STRING = 294,
     CODE = 295,
     XCODE = 296,
     SYMBOL = 297,
     VARIABLE = 298,
     IDENTIFIER = 299,
     ARG = 300,
     NUMBER = 301,
     BACKREF = 302,
     BUILTIN = 303,
     OR = 304,
     AND = 305,
     EQ = 306,
     NE = 307,
     LT = 308,
     LE = 309,
     GT = 310,
     GE = 311,
     NOT = 312,
     FUNCTION = 313,
     PROCEDURE = 314,
     TYPE = 315,
     UMINUS = 316
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define IF 267
#define FI 268
#define ELSE 269
#define ELIF 270
#define ON 271
#define HOST 272
#define FOR 273
#define FROM 274
#define AS 275
#define DO 276
#define DONE 277
#define POLL 278
#define MATCHES 279
#define FNMATCHES 280
#define MXMATCHES 281
#define MXFNMATCHES 282
#define WHEN 283
#define NEXT 284
#define SET 285
#define CATCH 286
#define KW_ECHO 287
#define RETURNS 288
#define RETURN 289
#define FUNC 290
#define SWITCH 291
#define CASE 292
#define DEFAULT 293
#define STRING 294
#define CODE 295
#define XCODE 296
#define SYMBOL 297
#define VARIABLE 298
#define IDENTIFIER 299
#define ARG 300
#define NUMBER 301
#define BACKREF 302
#define BUILTIN 303
#define OR 304
#define AND 305
#define EQ 306
#define NE 307
#define LT 308
#define LE 309
#define GT 310
#define GE 311
#define NOT 312
#define FUNCTION 313
#define PROCEDURE 314
#define TYPE 315
#define UMINUS 316




/* Copy the first part of user declarations.  */
#line 1 "gram.y"

/* This file is part of mailfrom filter.
   Copyright (C) 2005, 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <fnmatch.h>
#include <netdb.h>
#include "mailfrom.h"
#include "prog.h"
	
static NODE *alloc_node(enum node_type type, const struct locus *locus);
static void set_poll_arg(struct poll_data *poll, int kw, NODE *expr);
static int time_multiplier(const char *, unsigned *, unsigned *);
static int codegen(prog_counter_t *pc, NODE *node);
static NODE *reverse(NODE *in);
static NODE *function_call(struct function *function, size_t count,
			   NODE *subtree);
static data_type_t node_type(NODE *node);
static NODE *cast_to(data_type_t type, NODE *node);
static NODE *cast_arg_list(NODE *args, data_type_t *parmtype);
static struct variable *vardecl(char *name, data_type_t type,
				storage_class_t sc);
struct variable *externdecl(char *name, data_type_t type, STKVAL val);

static void register_auto(struct variable *var);
static void unregister_auto(struct variable *var);
static void forget_autos(void);
 
static NODE *root_node[smtp_state_count];
prog_counter_t entry_point[smtp_state_count];
 
int regex_flags;        /* Should default to REG_NOSUB ? */
unsigned error_count;   /* Number of detected errors */
size_t variable_count = 1; /* Offset of the next-to-be-defined variable
			      in the data segment */
static enum smtp_state state_tag; /* State tag of the currently processed
				     PROG */

static struct function *func;   /* The currently compiled function */
size_t auto_count;              /* Number of automatic variables declared
				   so far */
size_t param_count;             /* Number of parameters */
static prog_counter_t jump_pc;  /* Pointer to the chain of jmp instructions */

/* State handlers and their positional parameters */ 
struct state_parms {
	int cnt;                  /* Number or positional parameters */
	data_type_t types[2];   /* Their data types */
} state_parms[] = {
	{ 0,  }, /* smtp_state_none */
	{ 0,  }, /* smtp_state_connect */
	{ 1, { dtype_string } },  /* smtp_state_helo */
	{ 1, { dtype_string } },  /* smtp_state_envfrom */
	{ 1, { dtype_string } },  /* smtp_state_envrcpt */
	{ 2, { dtype_string, dtype_string } }, /* smtp_state_header */
	{ 0,  }, /* smtp_state_eoh */
	{ 2, { dtype_string, dtype_number } }, /* smtp_state_body */
	{ 0, }, /* smtp_state_eom */
};

struct parmtype {
	struct parmtype *next;
	data_type_t type;
};

#define	synt_none        0
#define	synt_handler     1
#define	synt_catch       2
#define	synt_function    3

static int stie_in;
static int allow_unquoted_strings;
 
static int
parmcount_none()
{
	return 0;
}

static data_type_t
parmtype_none(int n)
{
	return dtype_unspecified;
}
 
static int
parmcount_handler()
{
	return state_parms[state_tag].cnt;
}

static data_type_t
parmtype_handler(int n)
{
	return state_parms[state_tag].types[n-1];
}

static int
parmcount_catch()
{
	return 1;
}

static data_type_t
parmtype_catch(int n)
{
	return dtype_number;
}

static int
parmcount_function()
{
	return func->parmcount;
}

static data_type_t
parmtype_function(int n)
{
	return func->parmtype[n-1];
}

struct parminfo {
	int (*parmcount)(void);
	data_type_t (*parmtype)(int n);
} parminfo[] = {
	{ parmcount_none, parmtype_none },
	{ parmcount_handler, parmtype_handler },
	{ parmcount_catch, parmtype_catch },
	{ parmcount_function, parmtype_function }
};

#define PARMCOUNT() parminfo[stie_in].parmcount()
#define PARMTYPE(n) parminfo[stie_in].parmtype(n)

data_type_t
string_to_type(char *s)
{
	if (strcmp(s, "n") == 0)
		return dtype_number;
	else if (strcmp(s, "s") == 0)
		return dtype_string;
	else
		return dtype_unspecified;
}

const char *
type_to_string(data_type_t t)
{
	switch (t) {
	case dtype_number:
		return "number";
	case dtype_string:
		return "string";
	case dtype_unspecified:
		return "unspecified";
	default:
		abort();;
	}
}

static int
check_builtin(const struct builtin *bp)
{
	if (bp->statemask && !(EXMASK(state_tag) & bp->statemask)) {
		parse_error("Built-in function `%s' cannot be used in "
			    "prog `%s'",
			    bp->name,
			    state_to_string(state_tag));
		return 1;
	}
	if (bp->capture)
		capture_on();
	return 0;
}

static void jump_fixup(prog_counter_t pos, prog_counter_t endpos);
static NODE *create_on_node(NODE *sel, struct case_stmt *cases);
static void register_macro(enum smtp_state tag, char *macro);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 202 "gram.y"
{
	char *string;
	struct {
		NODE *head;
 		NODE *tail;
	} stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		int count;
	} parmlist;
	int tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
}
/* Line 193 of yacc.c.  */
#line 462 "gram.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 475 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  14
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   916

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  70
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  52
/* YYNRULES -- Number of rules.  */
#define YYNRULES  138
/* YYNRULES -- Number of states.  */
#define YYNSTATES  233

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   316

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      66,    67,    63,    61,    68,    62,     2,    64,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    69,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    65
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    16,    22,    24,    27,
      31,    35,    37,    43,    44,    46,    48,    52,    55,    57,
      59,    60,    63,    66,    68,    70,    73,    75,    77,    79,
      81,    83,    85,    87,    92,    96,    99,   103,   106,   109,
     112,   115,   117,   119,   121,   125,   129,   132,   135,   136,
     138,   140,   143,   147,   150,   152,   154,   156,   162,   163,
     168,   171,   177,   179,   182,   187,   191,   193,   197,   199,
     201,   203,   207,   211,   215,   219,   223,   227,   231,   235,
     239,   243,   246,   250,   252,   254,   256,   258,   260,   262,
     264,   267,   271,   275,   279,   283,   286,   290,   292,   294,
     296,   298,   300,   302,   304,   309,   313,   316,   321,   325,
     328,   330,   332,   334,   338,   340,   341,   348,   350,   352,
     354,   357,   363,   369,   371,   373,   376,   380,   383,   385,
     388,   391,   394,   397,   400,   402,   405,   406,   407
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      71,     0,    -1,    72,    -1,    73,    -1,    72,    73,    -1,
      11,    81,    21,    82,    22,    -1,    75,    76,    21,    82,
      22,    -1,    74,    -1,    60,    44,    -1,    30,    44,   105,
      -1,    30,    44,   101,    -1,    35,    -1,    44,    66,    77,
      67,    80,    -1,    -1,    78,    -1,    79,    -1,    78,    68,
      79,    -1,    60,    44,    -1,    60,    -1,    44,    -1,    -1,
      33,    60,    -1,    33,    44,    -1,    44,    -1,    83,    -1,
      82,    83,    -1,    90,    -1,    87,    -1,    85,    -1,    86,
      -1,   108,    -1,   111,    -1,    84,    -1,    59,    66,   106,
      67,    -1,    59,    66,    67,    -1,    59,   102,    -1,    30,
      44,   102,    -1,    60,    44,    -1,     3,    88,    -1,     4,
      88,    -1,     5,    88,    -1,     6,    -1,     7,    -1,    29,
      -1,     8,   105,   102,    -1,     9,   105,   102,    -1,    10,
     105,    -1,    32,   102,    -1,    -1,    89,    -1,    40,    -1,
      40,    41,    -1,    40,    41,   102,    -1,    40,   102,    -1,
      91,    -1,    93,    -1,   112,    -1,    12,    98,    82,    92,
      13,    -1,    -1,    15,    98,    82,    92,    -1,    14,    82,
      -1,    36,   102,    21,    94,    22,    -1,    95,    -1,    94,
      95,    -1,    37,    96,    69,    82,    -1,    38,    69,    82,
      -1,    97,    -1,    96,    49,    97,    -1,   105,    -1,   101,
      -1,   102,    -1,   102,    51,   102,    -1,   102,    52,   102,
      -1,   102,    53,   102,    -1,   102,    54,   102,    -1,   102,
      55,   102,    -1,   102,    56,   102,    -1,   102,    99,   102,
      -1,   102,   100,   102,    -1,    98,    49,    98,    -1,    98,
      50,    98,    -1,    57,    98,    -1,    66,    98,    67,    -1,
      24,    -1,    26,    -1,    25,    -1,    27,    -1,    46,    -1,
      40,    -1,   103,    -1,   102,   103,    -1,   102,    61,   102,
      -1,   102,    62,   102,    -1,   102,    63,   102,    -1,   102,
      64,   102,    -1,    62,   102,    -1,    66,   102,    67,    -1,
     105,    -1,    42,    -1,   101,    -1,    47,    -1,   107,    -1,
      45,    -1,   104,    -1,    48,    66,   106,    67,    -1,    48,
      66,    67,    -1,    48,   102,    -1,    58,    66,   106,    67,
      -1,    58,    66,    67,    -1,    58,   102,    -1,    39,    -1,
      44,    -1,   102,    -1,   106,    68,   102,    -1,    43,    -1,
      -1,    31,   110,    21,   109,    82,    22,    -1,    63,    -1,
      96,    -1,    34,    -1,    34,   102,    -1,   113,   115,   114,
     118,    22,    -1,   113,   104,   114,   118,    22,    -1,    16,
      -1,    21,    -1,    23,   102,    -1,    23,   102,   116,    -1,
      23,   116,    -1,   117,    -1,   116,   117,    -1,    18,   102,
      -1,    17,   102,    -1,    20,   102,    -1,    19,   102,    -1,
     119,    -1,   118,   119,    -1,    -1,    -1,    28,   120,    96,
      69,   121,    82,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   296,   296,   299,   300,   303,   317,   352,   355,   360,
     365,   372,   378,   401,   404,   407,   412,   421,   429,   435,
     448,   451,   455,   464,   476,   482,   495,   496,   497,   498,
     499,   500,   501,   504,   510,   516,   524,   540,   548,   556,
     566,   576,   582,   588,   592,   599,   606,   612,   620,   623,
     626,   632,   638,   644,   652,   653,   654,   657,   667,   670,
     677,   683,   724,   728,   735,   743,   753,   757,   765,   772,
     781,   782,   789,   796,   803,   810,   817,   824,   832,   840,
     847,   854,   860,   866,   871,   878,   883,   890,   891,   903,
     904,   910,   917,   924,   931,   938,   944,   950,   955,   961,
     966,   971,   992,  1002,  1005,  1024,  1038,  1057,  1063,  1069,
    1077,  1078,  1086,  1092,  1101,  1111,  1110,  1139,  1157,  1160,
    1174,  1194,  1239,  1245,  1251,  1257,  1266,  1275,  1281,  1286,
    1293,  1298,  1303,  1308,  1316,  1320,  1328,  1329,  1328
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACT_ACCEPT", "ACT_REJECT",
  "ACT_TEMPFAIL", "ACT_CONTINUE", "ACT_DISCARD", "ADD", "REPLACE",
  "DELETE", "PROG", "IF", "FI", "ELSE", "ELIF", "ON", "HOST", "FOR",
  "FROM", "AS", "DO", "DONE", "POLL", "MATCHES", "FNMATCHES", "MXMATCHES",
  "MXFNMATCHES", "WHEN", "NEXT", "SET", "CATCH", "KW_ECHO", "RETURNS",
  "RETURN", "FUNC", "SWITCH", "CASE", "DEFAULT", "STRING", "CODE", "XCODE",
  "SYMBOL", "VARIABLE", "IDENTIFIER", "ARG", "NUMBER", "BACKREF",
  "BUILTIN", "OR", "AND", "EQ", "NE", "LT", "LE", "GT", "GE", "NOT",
  "FUNCTION", "PROCEDURE", "TYPE", "'+'", "'-'", "'*'", "'/'", "UMINUS",
  "'('", "')'", "','", "':'", "$accept", "input", "decllist", "decl",
  "vardecl", "func", "fundecl", "parmdecl", "parmlist", "parm", "retdecl",
  "state_ident", "stmtlist", "stmt", "proccall", "asgn", "autodcl",
  "action", "maybe_triplet", "triplet", "condition", "if_cond",
  "else_cond", "case_cond", "cond_branches", "cond_branch", "valist",
  "value", "cond", "matches", "fnmatches", "number", "expr", "atom",
  "funcall", "string", "arglist", "variable", "catch", "@1", "catchlist",
  "return", "on_cond", "on", "do", "pollstmt", "pollarglist", "pollarg",
  "branches", "branch", "@2", "@3", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    43,    45,    42,    47,   316,    40,    41,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    70,    71,    72,    72,    73,    73,    73,    74,    74,
      74,    75,    76,    77,    77,    78,    78,    79,    79,    79,
      80,    80,    80,    81,    82,    82,    83,    83,    83,    83,
      83,    83,    83,    84,    84,    84,    85,    86,    87,    87,
      87,    87,    87,    87,    87,    87,    87,    87,    88,    88,
      89,    89,    89,    89,    90,    90,    90,    91,    92,    92,
      92,    93,    94,    94,    95,    95,    96,    96,    97,    97,
      98,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    99,    99,   100,   100,   101,   101,   102,
     102,   102,   102,   102,   102,   102,   102,   103,   103,   103,
     103,   103,   103,   103,   104,   104,   104,   104,   104,   104,
     105,   105,   106,   106,   107,   109,   108,   110,   110,   111,
     111,   112,   112,   113,   114,   115,   115,   115,   116,   116,
     117,   117,   117,   117,   118,   118,   120,   121,   119
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     5,     5,     1,     2,     3,
       3,     1,     5,     0,     1,     1,     3,     2,     1,     1,
       0,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     4,     3,     2,     3,     2,     2,     2,
       2,     1,     1,     1,     3,     3,     2,     2,     0,     1,
       1,     2,     3,     2,     1,     1,     1,     5,     0,     4,
       2,     5,     1,     2,     4,     3,     1,     3,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     3,     3,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     4,     3,     2,
       1,     1,     1,     3,     1,     0,     6,     1,     1,     1,
       2,     5,     5,     1,     1,     2,     3,     2,     1,     2,
       2,     2,     2,     2,     1,     2,     0,     0,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,    11,     0,     0,     2,     3,     7,     0,
      23,     0,     0,     8,     1,     4,     0,     0,     0,   110,
      88,   111,    87,    10,     9,    13,     0,    48,    48,    48,
      41,    42,     0,     0,     0,     0,   123,    43,     0,     0,
       0,   119,     0,     0,     0,     0,    24,    32,    28,    29,
      27,    26,    54,    55,    30,    31,    56,     0,    19,    18,
       0,    14,    15,     0,    50,    38,    49,    39,    40,     0,
       0,    46,    98,   114,   102,   100,     0,     0,     0,     0,
       0,     0,    99,    70,    89,   103,    97,   101,     0,   117,
     118,    66,    69,    68,     0,     0,    47,   120,     0,     0,
      35,    37,     5,    25,     0,     0,     0,    17,    20,     0,
       6,    51,    53,    44,    45,     0,   106,    81,     0,   109,
      95,     0,    70,     0,     0,    58,    83,    85,    84,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    90,    36,     0,   115,     0,     0,    34,   112,
       0,     0,     0,     0,     0,   125,   127,   128,   124,     0,
       0,     0,    12,    16,    52,   105,     0,   108,     0,    82,
      96,    79,    80,     0,     0,     0,    71,    72,    73,    74,
      75,    76,    91,    92,    93,    94,    77,    78,    67,     0,
       0,     0,     0,    62,    33,     0,   131,   130,   133,   132,
     126,   129,   136,     0,   134,     0,    22,    21,   104,   107,
      60,     0,    57,     0,     0,     0,    61,    63,   113,     0,
     122,   135,   121,    58,   116,     0,    65,     0,    59,    64,
     137,     0,   138
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,     7,     8,     9,    17,    60,    61,    62,
     162,    11,    45,    46,    47,    48,    49,    50,    65,    66,
      51,    52,   175,    53,   192,   193,    90,    91,    81,   140,
     141,    82,    83,    84,    85,    86,   150,    87,    54,   189,
      94,    55,    56,    57,   159,   106,   156,   157,   203,   204,
     219,   231
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -189
static const yytype_int16 yypact[] =
{
      -6,     1,    36,  -189,    38,    65,    -6,  -189,  -189,    44,
    -189,    73,    51,  -189,  -189,  -189,    30,    89,   456,  -189,
    -189,  -189,  -189,  -189,  -189,   -18,   456,    78,    78,    78,
    -189,  -189,    -9,    -9,    -9,   653,  -189,  -189,    87,    18,
     706,   706,   706,   731,    92,   228,  -189,  -189,  -189,  -189,
    -189,  -189,  -189,  -189,  -189,  -189,  -189,    -7,  -189,   100,
      79,    77,  -189,   388,   681,  -189,  -189,  -189,  -189,   706,
     706,  -189,  -189,  -189,  -189,  -189,   756,   653,   781,   706,
     653,   296,  -189,   540,  -189,  -189,  -189,  -189,   706,  -189,
      98,  -189,  -189,  -189,   127,   706,   806,   806,   514,   566,
     806,  -189,  -189,  -189,    95,   128,   128,  -189,   117,   -18,
    -189,   706,   806,   806,   806,   595,    31,  -189,   624,   806,
      31,   -31,   485,   653,   653,   354,  -189,  -189,  -189,  -189,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,  -189,   806,    51,  -189,   276,    15,  -189,   276,
      25,   706,   706,   706,   706,   459,   106,  -189,  -189,   124,
     124,    -5,  -189,  -189,   806,  -189,    49,  -189,    60,  -189,
    -189,   104,  -189,   456,   653,   142,   806,   806,   806,   806,
     806,   806,   832,   832,   858,   858,   806,   806,  -189,   456,
      51,    90,    47,  -189,  -189,   706,   806,   806,   806,   806,
     106,  -189,  -189,    12,  -189,    21,  -189,  -189,  -189,  -189,
     456,   296,  -189,   422,   -46,   456,  -189,  -189,   806,    51,
    -189,  -189,  -189,   354,  -189,   456,   456,   -36,  -189,   456,
    -189,   456,   456
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -189,  -189,  -189,   150,  -189,  -189,  -189,  -189,  -189,    53,
    -189,  -189,   -22,   -38,  -189,  -189,  -189,  -189,   101,  -189,
    -189,  -189,   -65,  -189,  -189,   -28,  -188,    16,   -63,  -189,
    -189,   -11,   -32,    99,   108,   -12,  -103,  -189,  -189,  -189,
    -189,  -189,  -189,  -189,    62,  -189,    11,  -150,     9,  -137,
    -189,  -189
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      24,    23,   214,   144,    63,     1,   201,   103,    96,    97,
      98,   100,   166,   144,   117,   168,   104,   121,   123,   124,
      69,    70,    71,   225,     2,   103,    58,    93,    92,     3,
      19,   227,   112,   230,   220,    21,   169,   113,   114,   206,
     202,    76,    59,   222,   116,    10,   119,   120,   122,   202,
     201,    78,   190,   191,     4,   207,   143,    19,    20,   125,
     171,   172,    21,   146,    22,    14,   221,   149,   221,   216,
      19,    20,   155,    72,    73,    21,    74,    22,    75,   164,
      12,    89,    13,   149,   190,   191,   149,   103,    16,    78,
      19,    20,   194,   195,    18,    21,    25,    22,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      26,   211,   151,   152,   153,   154,   208,   195,    64,   196,
     197,   198,   199,   151,   152,   153,   154,   209,   195,    67,
      68,    88,    93,    92,    19,    20,   101,    72,    73,    21,
      74,    22,    75,    76,   107,   109,   108,   144,   145,   158,
     161,   210,   202,    78,   124,   212,    15,    79,   228,   215,
     188,    95,   163,   218,   217,   105,   200,   213,   160,   205,
       0,     0,   103,     0,     0,   103,     0,     0,    93,    92,
       0,     0,   142,     0,     0,   103,     0,     0,   103,   223,
       0,   103,     0,   226,   103,   142,   142,   142,     0,   142,
       0,     0,     0,   229,     0,     0,     0,    93,    92,   232,
       0,   142,   142,   142,     0,   142,     0,     0,   142,   142,
       0,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,    28,    29,    30,    31,    32,    33,    34,     0,
      35,     0,   142,     0,    36,   142,     0,     0,   142,     0,
     102,     0,     0,     0,   142,     0,     0,    37,    38,    39,
      40,     0,    41,   142,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,    43,    44,     0,
       0,     0,     0,     0,     0,   142,   142,   142,   142,    27,
      28,    29,    30,    31,    32,    33,    34,     0,    35,     0,
       0,     0,    36,     0,     0,    19,    20,   142,    72,    73,
      21,    74,    22,    75,    76,    37,    38,    39,    40,     0,
      41,     0,    42,     0,    78,     0,     0,   136,   137,   138,
     139,     0,     0,   170,     0,   123,   124,     0,     0,     0,
       0,     0,     0,     0,     0,    43,    44,    27,    28,    29,
      30,    31,    32,    33,    34,     0,    35,     0,   173,   174,
      36,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,    38,    39,    40,     0,    41,     0,
      42,    27,    28,    29,    30,    31,    32,    33,    34,     0,
      35,     0,     0,     0,    36,     0,     0,     0,     0,     0,
     110,     0,     0,    43,    44,     0,     0,    37,    38,    39,
      40,     0,    41,     0,    42,    27,    28,    29,    30,    31,
      32,    33,    34,     0,    35,     0,     0,     0,    36,     0,
       0,     0,     0,     0,   224,     0,     0,    43,    44,     0,
       0,    37,    38,    39,    40,     0,    41,     0,    42,    27,
      28,    29,    30,    31,    32,    33,    34,     0,    35,     0,
       0,     0,    36,     0,     0,     0,   151,   152,   153,   154,
       0,    43,    44,     0,     0,    37,    38,    39,    40,     0,
      41,     0,    42,     0,     0,     0,     0,     0,    19,    20,
       0,    72,    73,    21,    74,    22,    75,    76,     0,   126,
     127,   128,   129,     0,     0,    43,    44,    78,     0,     0,
     136,   137,   138,   139,    19,    20,     0,    72,    73,    21,
      74,    22,    75,    76,     0,   147,   130,   131,   132,   133,
     134,   135,     0,    78,     0,     0,   136,   137,   138,   139,
       0,     0,   170,    19,    20,     0,    72,    73,    21,    74,
      22,    75,    76,     0,   126,   127,   128,   129,     0,     0,
       0,     0,    78,     0,     0,   136,   137,   138,   139,    19,
      20,     0,    72,    73,    21,    74,    22,    75,    76,     0,
       0,   130,   131,   132,   133,   134,   135,     0,    78,     0,
       0,   136,   137,   138,   139,    19,    20,     0,    72,    73,
      21,    74,    22,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,     0,    79,     0,
       0,     0,    95,   148,    19,    20,     0,    72,    73,    21,
      74,    22,    75,    76,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,    79,     0,     0,
       0,    95,   165,    19,    20,     0,    72,    73,    21,    74,
      22,    75,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,     0,     0,     0,    79,     0,     0,     0,
      95,   167,    19,    20,     0,    72,    73,    21,    74,    22,
      75,    76,     0,     0,     0,     0,     0,     0,     0,     0,
      77,    78,     0,     0,     0,    79,     0,     0,     0,    80,
      19,    20,   111,    72,    73,    21,    74,    22,    75,    76,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
       0,     0,     0,    79,     0,    19,    20,    95,    72,    73,
      21,    74,    22,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,     0,    79,     0,
      19,    20,    95,    72,    73,    21,    74,    22,    75,    76,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
       0,     0,     0,    79,     0,    19,    20,    99,    72,    73,
      21,    74,    22,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,     0,    79,     0,
      19,    20,   115,    72,    73,    21,    74,    22,    75,    76,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
       0,     0,     0,    79,     0,    19,    20,   118,    72,    73,
      21,    74,    22,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,   136,   137,   138,
     139,    19,    20,     0,    72,    73,    21,    74,    22,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,   138,   139,    19,    20,     0,
      72,    73,    21,    74,    22,    75,    76,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78
};

static const yytype_int16 yycheck[] =
{
      12,    12,   190,    49,    26,    11,   156,    45,    40,    41,
      42,    43,   115,    49,    77,   118,    23,    80,    49,    50,
      32,    33,    34,    69,    30,    63,    44,    39,    39,    35,
      39,   219,    64,    69,    22,    44,    67,    69,    70,    44,
      28,    48,    60,    22,    76,    44,    78,    79,    80,    28,
     200,    58,    37,    38,    60,    60,    88,    39,    40,    81,
     123,   124,    44,    95,    46,     0,   203,    99,   205,    22,
      39,    40,   104,    42,    43,    44,    45,    46,    47,   111,
      44,    63,    44,   115,    37,    38,   118,   125,    44,    58,
      39,    40,    67,    68,    21,    44,    66,    46,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      21,   174,    17,    18,    19,    20,    67,    68,    40,   151,
     152,   153,   154,    17,    18,    19,    20,    67,    68,    28,
      29,    44,   144,   144,    39,    40,    44,    42,    43,    44,
      45,    46,    47,    48,    44,    68,    67,    49,    21,    21,
      33,   173,    28,    58,    50,    13,     6,    62,   223,    69,
     144,    66,   109,   195,   192,    57,   155,   189,   106,   160,
      -1,    -1,   210,    -1,    -1,   213,    -1,    -1,   190,   190,
      -1,    -1,    83,    -1,    -1,   223,    -1,    -1,   226,   211,
      -1,   229,    -1,   215,   232,    96,    97,    98,    -1,   100,
      -1,    -1,    -1,   225,    -1,    -1,    -1,   219,   219,   231,
      -1,   112,   113,   114,    -1,   116,    -1,    -1,   119,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    -1,   143,    -1,    16,   146,    -1,    -1,   149,    -1,
      22,    -1,    -1,    -1,   155,    -1,    -1,    29,    30,    31,
      32,    -1,    34,   164,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    59,    60,    -1,
      -1,    -1,    -1,    -1,    -1,   196,   197,   198,   199,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    -1,
      -1,    -1,    16,    -1,    -1,    39,    40,   218,    42,    43,
      44,    45,    46,    47,    48,    29,    30,    31,    32,    -1,
      34,    -1,    36,    -1,    58,    -1,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    49,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    60,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    -1,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    -1,    34,    -1,
      36,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    59,    60,    -1,    -1,    29,    30,    31,
      32,    -1,    34,    -1,    36,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    -1,    -1,    -1,    16,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    59,    60,    -1,
      -1,    29,    30,    31,    32,    -1,    34,    -1,    36,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    -1,
      -1,    -1,    16,    -1,    -1,    -1,    17,    18,    19,    20,
      -1,    59,    60,    -1,    -1,    29,    30,    31,    32,    -1,
      34,    -1,    36,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    24,
      25,    26,    27,    -1,    -1,    59,    60,    58,    -1,    -1,
      61,    62,    63,    64,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    -1,    21,    51,    52,    53,    54,
      55,    56,    -1,    58,    -1,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    58,    -1,    -1,    61,    62,    63,    64,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    -1,
      -1,    61,    62,    63,    64,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    66,    67,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,
      66,    67,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    66,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    62,    -1,    39,    40,    66,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    -1,
      39,    40,    66,    42,    43,    44,    45,    46,    47,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    62,    -1,    39,    40,    66,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    -1,
      39,    40,    66,    42,    43,    44,    45,    46,    47,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    62,    -1,    39,    40,    66,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    61,    62,    63,
      64,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    63,    64,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    11,    30,    35,    60,    71,    72,    73,    74,    75,
      44,    81,    44,    44,     0,    73,    44,    76,    21,    39,
      40,    44,    46,   101,   105,    66,    21,     3,     4,     5,
       6,     7,     8,     9,    10,    12,    16,    29,    30,    31,
      32,    34,    36,    59,    60,    82,    83,    84,    85,    86,
      87,    90,    91,    93,   108,   111,   112,   113,    44,    60,
      77,    78,    79,    82,    40,    88,    89,    88,    88,   105,
     105,   105,    42,    43,    45,    47,    48,    57,    58,    62,
      66,    98,   101,   102,   103,   104,   105,   107,    44,    63,
      96,    97,   101,   105,   110,    66,   102,   102,   102,    66,
     102,    44,    22,    83,    23,   104,   115,    44,    67,    68,
      22,    41,   102,   102,   102,    66,   102,    98,    66,   102,
     102,    98,   102,    49,    50,    82,    24,    25,    26,    27,
      51,    52,    53,    54,    55,    56,    61,    62,    63,    64,
      99,   100,   103,   102,    49,    21,   102,    21,    67,   102,
     106,    17,    18,    19,    20,   102,   116,   117,    21,   114,
     114,    33,    80,    79,   102,    67,   106,    67,   106,    67,
      67,    98,    98,    14,    15,    92,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,    97,   109,
      37,    38,    94,    95,    67,    68,   102,   102,   102,   102,
     116,   117,    28,   118,   119,   118,    44,    60,    67,    67,
      82,    98,    13,    82,    96,    69,    22,    95,   102,   120,
      22,   119,    22,    82,    22,    69,    82,    96,    92,    82,
      69,   121,    82
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 304 "gram.y"
    {
		     root_node[(yyvsp[(2) - (5)].state)] = (yyvsp[(4) - (5)].stmtlist).head;
		     if (auto_count) {
			     code_instr(instr_stkalloc);
			     code_immediate((void*)auto_count);
		     }
		     if (codegen(&entry_point[(yyvsp[(2) - (5)].state)], (yyvsp[(4) - (5)].stmtlist).head))
			     error_count++;
		     else
			     milter_enable_state((yyvsp[(2) - (5)].state));
		     forget_autos();
		     stie_in = synt_none;
	     }
    break;

  case 6:
#line 318 "gram.y"
    {
		     prog_counter_t pc;

		     func->node = (yyvsp[(4) - (5)].stmtlist).head;
		     /* Assign the entry point early to properly
			handle recursive functions */
		     func->entry = code_get_counter();

		     /* Entry code */
		     if (func->exmask) {
			     code_instr(instr_saveex);
			     code_immediate((void*)func->exmask);
		     }

		     if (auto_count) {
			     code_instr(instr_stkalloc);
			     code_immediate((void*)auto_count);
		     }
		     
		     if (codegen(&pc, (yyvsp[(4) - (5)].stmtlist).head))
			     error_count++;
		     else {
			     jump_fixup(jump_pc, code_get_counter());

			     /* Exit code */
			     if (func->exmask) 
				     code_instr(instr_restex);
			     code_instr(instr_return);
		     }

		     forget_autos();
		     stie_in = synt_none;
		     func = NULL;
	     }
    break;

  case 8:
#line 356 "gram.y"
    {
		     if (!vardecl((yyvsp[(2) - (2)].string), (yyvsp[(1) - (2)].type), storage_extern))
			     YYERROR;
	     }
    break;

  case 9:
#line 361 "gram.y"
    {
		     if (!externdecl((yyvsp[(2) - (3)].string), dtype_string, (yyvsp[(3) - (3)].string)))
			     YYERROR;
	     }
    break;

  case 10:
#line 366 "gram.y"
    {
		     if (!externdecl((yyvsp[(2) - (3)].string), dtype_string, (STKVAL)(yyvsp[(3) - (3)].number)))
			     YYERROR;
	     }
    break;

  case 11:
#line 373 "gram.y"
    {
		     param_count = auto_count = 0;
	     }
    break;

  case 12:
#line 379 "gram.y"
    {
		     data_type_t *ptypes = NULL;
		     
		     if ((yyvsp[(3) - (5)].parmlist).count) {
			     int i;
			     struct parmtype *p;
			     
			     ptypes = emalloc((yyvsp[(3) - (5)].parmlist).count * sizeof *ptypes);
			     for (i = 0, p = (yyvsp[(3) - (5)].parmlist).head; p; i++) {
				     struct parmtype *next = p->next;
				     ptypes[i] = p->type;
				     free(p);
				     p = next;
			     }
		     }

		     (yyval.function) = func = function_install((yyvsp[(1) - (5)].string), (yyvsp[(3) - (5)].parmlist).count, ptypes, (yyvsp[(5) - (5)].type),
						  get_locus());
		     stie_in = synt_function;
	     }
    break;

  case 13:
#line 401 "gram.y"
    {
		     (yyval.parmlist).count = 0;
	     }
    break;

  case 15:
#line 408 "gram.y"
    {
		     (yyval.parmlist).count = 1;
		     (yyval.parmlist).head = (yyval.parmlist).tail = (yyvsp[(1) - (1)].parm);
	     }
    break;

  case 16:
#line 413 "gram.y"
    {
		     (yyvsp[(1) - (3)].parmlist).count++;
		     (yyvsp[(1) - (3)].parmlist).tail->next = (yyvsp[(3) - (3)].parm);
		     (yyvsp[(1) - (3)].parmlist).tail = (yyvsp[(3) - (3)].parm);
		     (yyval.parmlist) = (yyvsp[(1) - (3)].parmlist);
	     }
    break;

  case 17:
#line 422 "gram.y"
    {
		     if (!vardecl((yyvsp[(2) - (2)].string), (yyvsp[(1) - (2)].type), storage_param))
			     YYERROR;
		     (yyval.parm) = emalloc(sizeof *(yyval.parm));
		     (yyval.parm)->next = NULL;
		     (yyval.parm)->type = (yyvsp[(1) - (2)].type);
	     }
    break;

  case 18:
#line 430 "gram.y"
    {
		     (yyval.parm) = emalloc(sizeof *(yyval.parm));
		     (yyval.parm)->next = NULL;
		     (yyval.parm)->type = (yyvsp[(1) - (1)].type);
	     }
    break;

  case 19:
#line 436 "gram.y"
    {
		     (yyval.parm) = emalloc(sizeof *(yyval.parm));
		     (yyval.parm)->next = NULL;
		     if (((yyval.parm)->type = string_to_type((yyvsp[(1) - (1)].string)))
			 == dtype_unspecified) {
			     parse_error("unknown type specification: %s", (yyvsp[(1) - (1)].string));
			     error_count++;
		     }
	     }
    break;

  case 20:
#line 448 "gram.y"
    {
		     (yyval.type) = dtype_unspecified;
	     }
    break;

  case 21:
#line 452 "gram.y"
    {
		     (yyval.type) = (yyvsp[(2) - (2)].type);
	     }
    break;

  case 22:
#line 456 "gram.y"
    {
		     if (((yyval.type) = string_to_type((yyvsp[(2) - (2)].string))) == dtype_unspecified) {
			     parse_error("unknown type specification: %s", (yyvsp[(2) - (2)].string));
			     error_count++;
		     }
	     }
    break;

  case 23:
#line 465 "gram.y"
    {
		     (yyval.state) = string_to_state((yyvsp[(1) - (1)].string));
		     if ((yyval.state) == smtp_state_none) {
			     parse_error("Unknown smtp state tag: %s", (yyvsp[(1) - (1)].string));
			     error_count++;
		     }
		     state_tag = (yyval.state);
		     stie_in = synt_handler;
	     }
    break;

  case 24:
#line 477 "gram.y"
    {
		     if ((yyvsp[(1) - (1)].node)) 
			     (yyvsp[(1) - (1)].node)->next = NULL;
		     (yyval.stmtlist).head = (yyval.stmtlist).tail = (yyvsp[(1) - (1)].node);
	     }
    break;

  case 25:
#line 483 "gram.y"
    {
		     if ((yyvsp[(2) - (2)].node)) {
			     if ((yyvsp[(1) - (2)].stmtlist).tail) 
				     (yyvsp[(1) - (2)].stmtlist).tail->next = (yyvsp[(2) - (2)].node);
			     else
				     (yyvsp[(1) - (2)].stmtlist).head = (yyvsp[(2) - (2)].node);
			     (yyvsp[(1) - (2)].stmtlist).tail = (yyvsp[(2) - (2)].node);
		     }
		     (yyval.stmtlist) = (yyvsp[(1) - (2)].stmtlist);
	     }
    break;

  case 33:
#line 505 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (4)].function), (yyvsp[(3) - (4)].arglist).count, (yyvsp[(3) - (4)].arglist).head);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 34:
#line 511 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (3)].function), 0, NULL);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 35:
#line 517 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (2)].function), 1, (yyvsp[(2) - (2)].node));
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 36:
#line 525 "gram.y"
    {
		     struct variable *var;

		     var = variable_lookup((yyvsp[(2) - (3)].string));
		     if (!var)
			     /* FIXME: Should the default be auto? */
			     var = vardecl((yyvsp[(2) - (3)].string), node_type((yyvsp[(3) - (3)].node)), storage_extern);
		     if (!var)
			     YYERROR;
		     (yyval.node) = alloc_node(node_type_asgn, &(yyvsp[(1) - (3)].locus));
		     (yyval.node)->v.asgn.var = var;
		     (yyval.node)->v.asgn.node = cast_to(var->type, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 37:
#line 541 "gram.y"
    {
		     if (!vardecl((yyvsp[(2) - (2)].string), (yyvsp[(1) - (2)].type), storage_auto))
			     YYERROR;
		     (yyval.node) = NULL;
	     }
    break;

  case 38:
#line 549 "gram.y"
    {
		     if ((yyvsp[(2) - (2)].ret).code || (yyvsp[(2) - (2)].ret).xcode || (yyvsp[(2) - (2)].ret).message)
			     parse_error("warning: arguments are ignored for accept");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_ACCEPT;
	     }
    break;

  case 39:
#line 557 "gram.y"
    {
		     if  ((yyvsp[(2) - (2)].ret).code && (yyvsp[(2) - (2)].ret).code[0] != '5')
			     parse_error("reject code should be 5xx");
		     if  ((yyvsp[(2) - (2)].ret).xcode && (yyvsp[(2) - (2)].ret).xcode[0] != '5')
			     parse_error("reject extended code should be 5.x.x");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_REJECT;
	     }
    break;

  case 40:
#line 567 "gram.y"
    {
		     if  ((yyvsp[(2) - (2)].ret).code && (yyvsp[(2) - (2)].ret).code[0] != '4')
			     parse_error("tempfail code should be 4xx");
		     if  ((yyvsp[(2) - (2)].ret).xcode && (yyvsp[(2) - (2)].ret).xcode[0] != '4')
			     parse_error("tempfail extended code should be 4.x.x");
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_TEMPFAIL;
	     }
    break;

  case 41:
#line 577 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (1)].locus));
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_CONTINUE;
	     }
    break;

  case 42:
#line 583 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_result, &(yyvsp[(1) - (1)].locus));
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_DISCARD;
	     }
    break;

  case 43:
#line 589 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_next, &(yyvsp[(1) - (1)].locus));
	     }
    break;

  case 44:
#line 593 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (3)].locus));
		     (yyval.node)->v.hdr.opcode = header_add;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].string);
		     (yyval.node)->v.hdr.value = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 45:
#line 600 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (3)].locus));
		     (yyval.node)->v.hdr.opcode = header_replace;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].string);
		     (yyval.node)->v.hdr.value = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 46:
#line 607 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_header, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.hdr.opcode = header_delete;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (2)].string);
	     }
    break;

  case 47:
#line 613 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_echo, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.node = cast_to(dtype_string, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 48:
#line 620 "gram.y"
    {
		     memset(&(yyval.ret), 0, sizeof (yyval.ret));
	     }
    break;

  case 50:
#line 627 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (1)].string);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = NULL;
	     }
    break;

  case 51:
#line 633 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (2)].string);
		     (yyval.ret).xcode = (yyvsp[(2) - (2)].string);
		     (yyval.ret).message = NULL;
	     }
    break;

  case 52:
#line 639 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (3)].string);
		     (yyval.ret).xcode = (yyvsp[(2) - (3)].string);
		     (yyval.ret).message = (yyvsp[(3) - (3)].node);
	     }
    break;

  case 53:
#line 645 "gram.y"
    {
		     (yyval.ret).code = (yyvsp[(1) - (2)].string);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 57:
#line 658 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_if, &(yyvsp[(1) - (5)].locus));
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (5)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (5)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (5)].node);
	     }
    break;

  case 58:
#line 667 "gram.y"
    {
		     (yyval.node) = NULL;
	     }
    break;

  case 59:
#line 671 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_if, &(yyvsp[(1) - (4)].locus));
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (4)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (4)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (4)].node);
	     }
    break;

  case 60:
#line 678 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (2)].stmtlist).head;
	     }
    break;

  case 61:
#line 684 "gram.y"
    {
		     struct case_stmt *defcase = NULL, *pcase, *prev;
		     
		     (yyval.node) = alloc_node(node_type_switch, &(yyvsp[(1) - (5)].locus));
		     (yyval.node)->v.switch_stmt.node = (yyvsp[(2) - (5)].node);
		     
		     /* Make sure there is only one default case and
			place it at the beginning of the list */
		     pcase = (yyvsp[(4) - (5)].case_list).head;
		     if (!pcase->valist) {
			     defcase = pcase;
			     (yyvsp[(4) - (5)].case_list).head = (yyvsp[(4) - (5)].case_list).head->next;
		     }
		     prev = pcase;
		     pcase = pcase->next;
		     while (pcase) {
			     if (!pcase->valist) {
				     if (defcase) {
					     parse_error_locus(&pcase->locus,
					       "duplicate default statement");
					     parse_error_locus(&defcase->locus,
					       "previously defined here");
					     YYERROR;
				     }
				     defcase = pcase;
				     prev->next = pcase->next;
			     } else
				     prev = pcase;
			     pcase = pcase->next;
		     }

		     if (defcase) {
			     defcase->next = (yyvsp[(4) - (5)].case_list).head;
			     (yyvsp[(4) - (5)].case_list).head = defcase;
		     }

		     (yyval.node)->v.switch_stmt.cases = (yyvsp[(4) - (5)].case_list).head;
	     }
    break;

  case 62:
#line 725 "gram.y"
    {
		       (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
	       }
    break;

  case 63:
#line 729 "gram.y"
    {
		       (yyval.case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
		       (yyval.case_list).tail = (yyvsp[(2) - (2)].case_stmt);
	       }
    break;

  case 64:
#line 736 "gram.y"
    {
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (4)].locus);
		     (yyval.case_stmt)->valist = (yyvsp[(2) - (4)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(4) - (4)].stmtlist).head;
	     }
    break;

  case 65:
#line 744 "gram.y"
    {
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (3)].locus);
		     (yyval.case_stmt)->valist = NULL;
		     (yyval.case_stmt)->node = (yyvsp[(3) - (3)].stmtlist).head;
	     }
    break;

  case 66:
#line 754 "gram.y"
    {
		     (yyval.valist_list).head = (yyval.valist_list).tail = (yyvsp[(1) - (1)].valist);
	     }
    break;

  case 67:
#line 758 "gram.y"
    {
		     (yyvsp[(1) - (3)].valist_list).tail->next = (yyvsp[(3) - (3)].valist);
		     (yyvsp[(1) - (3)].valist_list).tail = (yyvsp[(3) - (3)].valist);
		     (yyval.valist_list) = (yyvsp[(1) - (3)].valist_list);
	     }
    break;

  case 68:
#line 766 "gram.y"
    {
		     (yyval.valist) = emalloc(sizeof *(yyval.valist));
		     (yyval.valist)->next = NULL;
		     (yyval.valist)->value.type = dtype_string;
		     (yyval.valist)->value.v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 69:
#line 773 "gram.y"
    {
		     (yyval.valist) = emalloc(sizeof *(yyval.valist));
		     (yyval.valist)->next = NULL;
		     (yyval.valist)->value.type = dtype_number;
		     (yyval.valist)->value.v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 71:
#line 783 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_eq;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 72:
#line 790 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_ne;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 73:
#line 797 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_lt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 74:
#line 804 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_le;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 75:
#line 811 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_gt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 76:
#line 818 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_ge;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 77:
#line 825 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].matchtype).locus);
		     (yyval.node)->v.bin.opcode = bin_match;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 78:
#line 833 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].matchtype).locus);
		     (yyval.node)->v.bin.opcode = bin_fnmatch;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 79:
#line 841 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_or;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 80:
#line 848 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yyvsp[(2) - (3)].locus));
		     (yyval.node)->v.bin.opcode = bin_and;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 81:
#line 855 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_un, &(yyvsp[(1) - (2)].locus));
		     (yyval.node)->v.un.opcode = unary_not;
		     (yyval.node)->v.un.arg = cast_to(dtype_number, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 82:
#line 861 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (3)].node);
	     }
    break;

  case 83:
#line 867 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 84:
#line 872 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 85:
#line 879 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 86:
#line 884 "gram.y"
    {
		     (yyval.matchtype).locus = (yyvsp[(1) - (1)].locus);
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 88:
#line 892 "gram.y"
    {
		     char *p;
		     (yyval.number) = strtol((yyvsp[(1) - (1)].string), &p, 10);
		     if (*p) {
			     /* should not happen */
			     parse_error("Invalid number (near `%s')", p);
			     YYERROR;
		     }
	     }
    break;

  case 90:
#line 905 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_concat, get_locus());
		     (yyval.node)->v.concat.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (2)].node));
		     (yyval.node)->v.concat.arg[1] = cast_to(dtype_string, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 91:
#line 911 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_add;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 92:
#line 918 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_sub;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 93:
#line 925 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_mul;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 94:
#line 932 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, get_locus());
		     (yyval.node)->v.bin.opcode = bin_div;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 95:
#line 939 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_un, get_locus());
		     (yyval.node)->v.un.opcode = unary_minus;
		     (yyval.node)->v.un.arg = cast_to(dtype_number, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 96:
#line 945 "gram.y"
    {
		     (yyval.node) = (yyvsp[(2) - (3)].node);
	     }
    break;

  case 97:
#line 951 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_string, get_locus());
		     (yyval.node)->v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 98:
#line 956 "gram.y"
    {
		     register_macro(state_tag, (yyvsp[(1) - (1)].string));
		     (yyval.node) = alloc_node(node_type_symbol, get_locus());
		     (yyval.node)->v.string = (yyvsp[(1) - (1)].string);
	     }
    break;

  case 99:
#line 962 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_number, get_locus());
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 100:
#line 967 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_backref, get_locus());
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 101:
#line 972 "gram.y"
    {
		     switch ((yyvsp[(1) - (1)].var)->storage_class) {
		     case storage_param:
			     (yyval.node) = alloc_node(node_type_arg, get_locus());
			     (yyval.node)->v.arg.data_type = (yyvsp[(1) - (1)].var)->type;
			     (yyval.node)->v.arg.number = (yyvsp[(1) - (1)].var)->off;
			     break;

		     case storage_auto:
			     (yyval.node) = alloc_node(node_type_auto, get_locus());
			     (yyval.node)->v.arg.data_type = (yyvsp[(1) - (1)].var)->type;
			     (yyval.node)->v.arg.number = (yyvsp[(1) - (1)].var)->off;
			     break;
			     
		     case storage_extern:
			     (yyval.node) = alloc_node(node_type_variable, get_locus());
			     (yyval.node)->v.variable = (yyvsp[(1) - (1)].var);
			     break;
		     }
	     }
    break;

  case 102:
#line 993 "gram.y"
    {
		     if ((yyvsp[(1) - (1)].number) > PARMCOUNT()) { 
			     parse_error("Argument number too high");
			     error_count++;
		     }
		     (yyval.node) = alloc_node(node_type_arg, get_locus());
		     (yyval.node)->v.arg.data_type = PARMTYPE((yyvsp[(1) - (1)].number));
		     (yyval.node)->v.arg.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 104:
#line 1006 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (4)].builtin)))
			     YYERROR;
		     if ((yyvsp[(3) - (4)].arglist).count < (yyvsp[(1) - (4)].builtin)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else if ((yyvsp[(3) - (4)].arglist).count > (yyvsp[(1) - (4)].builtin)->parmcount) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (4)].builtin);
			     (yyval.node)->v.builtin.args = cast_arg_list((yyvsp[(3) - (4)].arglist).head,
								(yyvsp[(1) - (4)].builtin)->parmtype);
		     }
	     }
    break;

  case 105:
#line 1025 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (3)].builtin)))
			     YYERROR;
		     if ((yyvsp[(1) - (3)].builtin)->parmcount) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (3)].builtin)->name);
			     YYERROR;
		     } else {
 			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (3)].builtin);
			     (yyval.node)->v.builtin.args = NULL;
		     }
	     }
    break;

  case 106:
#line 1039 "gram.y"
    {
		     if (check_builtin((yyvsp[(1) - (2)].builtin)))
			     YYERROR;
		     if ((yyvsp[(1) - (2)].builtin)->parmcount > 1) {
			     parse_error("Too few arguments in call to `%s'",
					 (yyvsp[(1) - (2)].builtin)->name);
			     YYERROR;
		     } else if ((yyvsp[(1) - (2)].builtin)->parmcount == 0) {
			     parse_error("Too many arguments in call to `%s'",
					 (yyvsp[(1) - (2)].builtin)->name);
			     YYERROR;
		     } else {
			     (yyval.node) = alloc_node(node_type_builtin, get_locus());
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (2)].builtin);
			     (yyval.node)->v.builtin.args = cast_arg_list((yyvsp[(2) - (2)].node),
								(yyvsp[(1) - (2)].builtin)->parmtype);
		     }
	     }
    break;

  case 107:
#line 1058 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (4)].function), (yyvsp[(3) - (4)].arglist).count, (yyvsp[(3) - (4)].arglist).head);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 108:
#line 1064 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (3)].function), 0, NULL);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 109:
#line 1070 "gram.y"
    {
		     (yyval.node) = function_call((yyvsp[(1) - (2)].function), 1, (yyvsp[(2) - (2)].node));
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 111:
#line 1079 "gram.y"
    {
		     if (!allow_unquoted_strings)
			     parse_error("warning: unquoted identifier `%s'",
					 (yyvsp[(1) - (1)].string));
	     }
    break;

  case 112:
#line 1087 "gram.y"
    {
		     (yyvsp[(1) - (1)].node)->next = NULL;
		     (yyval.arglist).head = (yyval.arglist).tail = (yyvsp[(1) - (1)].node);
		     (yyval.arglist).count = 1;
	     }
    break;

  case 113:
#line 1093 "gram.y"
    {
		     (yyvsp[(1) - (3)].arglist).tail->next = (yyvsp[(3) - (3)].node);
		     (yyvsp[(1) - (3)].arglist).tail = (yyvsp[(3) - (3)].node);
		     (yyvsp[(1) - (3)].arglist).count++;
		     (yyval.arglist) = (yyvsp[(1) - (3)].arglist);
	     }
    break;

  case 114:
#line 1102 "gram.y"
    {
		     (yyval.var) = variable_lookup((yyvsp[(1) - (1)].string));
		     if (!(yyval.var)) {
			     parse_error("Variable %s is not defined", (yyvsp[(1) - (1)].string));
			     YYERROR;
		     }
	     }
    break;

  case 115:
#line 1111 "gram.y"
    { (yyval.tie_in) = stie_in; stie_in = synt_catch; }
    break;

  case 116:
#line 1113 "gram.y"
    {
		      int i;
		      struct valist *p;

		      stie_in = (yyvsp[(4) - (6)].tie_in);
		      (yyval.node) = alloc_node(node_type_catch, &(yyvsp[(1) - (6)].locus));
		      for (i = 0, p = (yyvsp[(2) - (6)].valist_list).head; p; p = p->next)
			      i++;
		      (yyval.node)->v.catch.count = i;
		      (yyval.node)->v.catch.exmask = 0;
		      for (i = 0, p = (yyvsp[(2) - (6)].valist_list).head; p; p = p->next, i++) {
			      if (p->value.type != dtype_number) {
				      parse_error_locus(&(yyvsp[(1) - (6)].locus),
							"expected numeric value, but found `%s'",
							p->value.v.string);
				      error_count++;
				      continue;
			      }
			      (yyval.node)->v.catch.exmask |= EXMASK(p->value.v.number);
			      if (stie_in == synt_function)
				      func->exmask |= EXMASK(p->value.v.number);
		      }
		      (yyval.node)->v.catch.node = (yyvsp[(5) - (6)].stmtlist).head;
	      }
    break;

  case 117:
#line 1140 "gram.y"
    {
		      int i;

		      (yyval.valist_list).head = (yyval.valist_list).tail = NULL;
		      for (i = 0; i < mf_status_count; i++) {
			      struct valist *p = emalloc(sizeof *p);
			      p->next = NULL; 
			      p->value.type = dtype_number;
			      p->value.v.number = i;
			      if (!(yyval.valist_list).head)
				      (yyval.valist_list).head = (yyval.valist_list).tail = p;
			      else {
				      (yyval.valist_list).tail->next = p;
				      (yyval.valist_list).tail = p;
			      }
		      }
	      }
    break;

  case 119:
#line 1161 "gram.y"
    {
		      if (!func) {
			      parse_error("`return' outside of a function");
			      error_count++;
		      } else if (func->rettype != dtype_unspecified) {
			      parse_error(
				      "`return' with no value, in function "
				      "returning non-void");
			      error_count++;
		      }		      
		      (yyval.node) = alloc_node(node_type_return, &(yyvsp[(1) - (1)].locus));
		      (yyval.node)->v.node = NULL;
	      }
    break;

  case 120:
#line 1175 "gram.y"
    {
		      if (!func) {
			      parse_error("`return' outside of a function");
			      error_count++;
		      } else if (func->rettype == dtype_unspecified) {
			      parse_error(
				       "`return' with a value, in function "
				       "returning void");
			      error_count++;
		      }
		      (yyval.node) = alloc_node(node_type_return, &(yyvsp[(1) - (2)].locus));
		      (yyval.node)->v.node = cast_to(func->rettype, (yyvsp[(2) - (2)].node));
	      }
    break;

  case 121:
#line 1195 "gram.y"
    {
		     NODE *sel, *np;
		     NODE *head = NULL, *tail;
		     const struct builtin *bi;
		     
		     /* Build argument list */
		     if ((yyvsp[(2) - (5)].poll).client_addr) {
			     head = tail = (yyvsp[(2) - (5)].poll).client_addr;
			     tail = (yyvsp[(2) - (5)].poll).email;
			     tail->next = NULL;
			     head->next = tail;
		     } else
			     head = tail = (yyvsp[(2) - (5)].poll).email;

		     if ((yyvsp[(2) - (5)].poll).ehlo)
			     np = (yyvsp[(2) - (5)].poll).ehlo;
		     else {
			     np = alloc_node(node_type_variable, get_locus());
			     np->v.variable = variable_lookup("ehlo_domain");
		     }
		     tail->next = np;
		     tail = np;

		     if ((yyvsp[(2) - (5)].poll).mailfrom)
			     np = (yyvsp[(2) - (5)].poll).mailfrom;
		     else {
			     np = alloc_node(node_type_variable, get_locus());
			     np->v.variable =
				     variable_lookup("mailfrom_address");
		     }
		     tail->next = np;
		     tail = np;

		     if ((yyvsp[(2) - (5)].poll).client_addr) 
			     bi = builtin_lookup("strictpoll");
		     else
			     bi = builtin_lookup("stdpoll");
		     
		     sel = alloc_node(node_type_builtin, &(yyvsp[(1) - (5)].locus));
		     sel->v.builtin.builtin = bi;
		     sel->v.builtin.args = head;

		     (yyval.node) = create_on_node(sel, (yyvsp[(4) - (5)].case_list).head);
	     }
    break;

  case 122:
#line 1240 "gram.y"
    {
		     (yyval.node) = create_on_node((yyvsp[(2) - (5)].node), (yyvsp[(4) - (5)].case_list).head);
	     }
    break;

  case 123:
#line 1246 "gram.y"
    {
		     onblock(1);
	     }
    break;

  case 124:
#line 1252 "gram.y"
    {
		     onblock(0);
	     }
    break;

  case 125:
#line 1258 "gram.y"
    {
		     struct pollarg arg;
		     
		     arg.kw = FOR;
		     arg.expr = (yyvsp[(2) - (2)].node);
		     memset(&(yyval.poll), 0, sizeof (yyval.poll));
		     set_poll_arg(&(yyval.poll), arg.kw, arg.expr);
	     }
    break;

  case 126:
#line 1267 "gram.y"
    {
		     struct pollarg arg;
		     
		     arg.kw = FOR;
		     arg.expr = (yyvsp[(2) - (3)].node);
		     set_poll_arg(&(yyvsp[(3) - (3)].poll), arg.kw, arg.expr);
		     (yyval.poll) = (yyvsp[(3) - (3)].poll);
	     }
    break;

  case 127:
#line 1276 "gram.y"
    {
		     (yyval.poll) = (yyvsp[(2) - (2)].poll);
	     }
    break;

  case 128:
#line 1282 "gram.y"
    {
		     memset(&(yyval.poll), 0, sizeof (yyval.poll));
		     set_poll_arg(&(yyval.poll), (yyvsp[(1) - (1)].pollarg).kw, (yyvsp[(1) - (1)].pollarg).expr);
	     }
    break;

  case 129:
#line 1287 "gram.y"
    {
		     set_poll_arg(&(yyvsp[(1) - (2)].poll), (yyvsp[(2) - (2)].pollarg).kw, (yyvsp[(2) - (2)].pollarg).expr);
		     (yyval.poll) = (yyvsp[(1) - (2)].poll);
	     }
    break;

  case 130:
#line 1294 "gram.y"
    {
		     (yyval.pollarg).kw = FOR;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 131:
#line 1299 "gram.y"
    {
		     (yyval.pollarg).kw = HOST;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 132:
#line 1304 "gram.y"
    {
		     (yyval.pollarg).kw = AS;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 133:
#line 1309 "gram.y"
    {
		     (yyval.pollarg).kw = FROM;
		     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 134:
#line 1317 "gram.y"
    {
		     (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
	     }
    break;

  case 135:
#line 1321 "gram.y"
    {
		     (yyvsp[(1) - (2)].case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
		     (yyvsp[(1) - (2)].case_list).tail = (yyvsp[(2) - (2)].case_stmt);
		     (yyval.case_list) = (yyvsp[(1) - (2)].case_list);
	     }
    break;

  case 136:
#line 1328 "gram.y"
    { allow_unquoted_strings = 1; }
    break;

  case 137:
#line 1329 "gram.y"
    { allow_unquoted_strings = 0; }
    break;

  case 138:
#line 1330 "gram.y"
    {
		     struct valist *p;

		     for (p = (yyvsp[(3) - (6)].valist_list).head; p; p = p->next) {
			     if (p->value.type == dtype_string) {
				     mf_status status;
				     if (string_to_stat(p->value.v.string,
							&status)) {
				        parse_error("Unknown return code: %s",
						    p->value.v.string);
					YYERROR;
				     }
				     p->value.type = dtype_number;
				     p->value.v.number = status;
			     }
		     }
		     
		     (yyval.case_stmt) = emalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
		     (yyval.case_stmt)->locus = (yyvsp[(1) - (6)].locus);
		     (yyval.case_stmt)->valist = (yyvsp[(3) - (6)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(6) - (6)].stmtlist).head;
	     }
    break;


/* Line 1267 of yacc.c.  */
#line 3322 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 1355 "gram.y"


int
yyerror(char *s)
{
	parse_error("%s", s);
	error_count++;
}


int
parse_config(char *name, int ydebug, int ldebug)
{
	yydebug = ydebug;
	if (source(name, ldebug))
		return -1;
	stie_in = synt_none;
	code_immediate(NULL); /* Reserve 0 slot */
	return yyparse() + error_count;
}

NODE *
alloc_node(enum node_type type, const struct locus *locus)
{
	NODE *node = malloc(sizeof(*node));
	if (!node) {
		yyerror("Not enough memory");
		abort();
	}
	node->type = type;
	node->locus = *locus;
	node->next = NULL;
	return node;
}


static struct status_tab {
	mf_status status;
	char *name;
} status_tab[] = {
	{ mf_success, "success" },
	{ mf_not_found, "not_found" },
	{ mf_failure, "failure" }, 
	{ mf_temp_failure, "temp_failure" },

	{ mf_ston_conv, "ston_conv" },
        { mf_divzero, "divzero" },
        { mf_regcomp, "regcomp" },
        { mf_invip, "invip" },
        { mf_invcidr, "invcidr" },
        { mf_invtime, "invtime" },
        { mf_dbfailure, "dbfailure" },
	{ mf_range, "range" },
	{ mf_url, "url" },
	{ 0, NULL }
};

int
string_to_stat(char *str, mf_status *status)
{
	struct status_tab *sp;
	for (sp = status_tab; sp->name; sp++)
		if (strcmp(str, sp->name) == 0) {
			*status = sp->status;
			return 0;
		}
	return 1;
}

const char *
mf_status_str(mf_status stat)
{
	struct status_tab *sp;
	for (sp = status_tab; sp->name; sp++)
		if (sp->status == stat)
			return sp->name;
	return "UNKNOWN";
}


/* Print parse tree */

static void print_node_list(NODE *node, int indent);
static void print_node(NODE *node, int indent);
void print_stat(sfsistat stat);
static int dbg_setreply(void *data, char *code, char *xcode, char *message);
static void dbg_setheader(void *data, struct old_header_node *hdr);

static void
print_level(int level)
{
	level *= 2;
	printf("%*.*s", level, level, "");
}

static void
print_bin_op(enum bin_opcode opcode)
{
	char *p;
	switch (opcode) {
	case bin_and:
		p = "AND";
		break;
		
	case bin_or:
		p = "OR";
		break;
		
	case bin_eq:
		p = "EQ";
		break;
		
	case bin_ne:
		p = "NE";
		break;
		
	case bin_lt:
		p = "LT";
		break;
		
	case bin_le:
		p = "LE";
		break;
		
	case bin_gt:
		p = "GT";
		break;
		
	case bin_ge:
		p = "GE";
		break;
		
	case bin_match:
		p = "MATCH";
		break;
		
	case bin_fnmatch:
		p = "FNMATCH";
		break;

	case bin_add:
		p = "ADD";
		break;
		
	case bin_sub:
		p = "SUB";
		break;
		
	case bin_mul:
		p = "MUL";
		break;
		
	case bin_div:
		p = "DIV";
		break;
		
	default:
		p = "UNKNOWN_OP";
	}
	printf("%s", p);
}

static void
print_node(NODE *node, int level)
{
	switch (node->type) {
	case node_type_string:
		print_level(level);
		printf("CONSTANT: %s\n", node->v.string);
		break;
		
	case node_type_symbol:
		print_level(level);
		printf("SYMBOL: %s\n", node->v.string);
		break;
		
	case node_type_number:
		print_level(level);
		printf("NUMBER: %ld\n", node->v.number);
		break;

	case node_type_backref:
		print_level(level);
		printf("BACKREF: %ld\n", node->v.number);
		break;
		
	case node_type_variable:
		print_level(level);
		printf("VARIABLE %s %s (%lu)\n",
		       storage_class_str(node->v.asgn.var->storage_class),
		       node->v.asgn.var->name,
		       (unsigned long) node->v.asgn.var->off);
		break;

	case node_type_arg:
		print_level(level);
		printf("ARG %lu\n", node->v.arg.number);
		break;

	case node_type_auto:
		print_level(level);
		printf("AUTO %lu\n", node->v.arg.number);
		break;
		
	case node_type_asgn:
		print_level(level);
		printf("SET %s %s (%lu)\n",
		       storage_class_str(node->v.asgn.var->storage_class),
		       node->v.asgn.var->name,
		       (unsigned long) node->v.asgn.var->off);
		print_node(node->v.asgn.node, level + 1);
		break;
		
	case node_type_if:
		print_level(level);
		printf("COND: \n");
		print_node(node->v.cond.cond, level);
		print_level(level);
		printf("IFTRUE\n");
		print_node_list(node->v.cond.if_true, level+1);
		print_level(level);
		printf("IFFALSE\n");
		print_node_list(node->v.cond.if_false, level+1);
		break;

	case node_type_switch:
	{
		struct case_stmt *pcase;
		
		print_level(level);
		printf("SWITCH: \n");
		print_node(node->v.switch_stmt.node, level+1);
		for (pcase = node->v.switch_stmt.cases;
		     pcase; pcase = pcase->next) {
			
			print_level(level+1);
			if (pcase->valist) {
				struct valist *vp;

				printf("CASE ");
				for (vp = pcase->valist; vp; vp = vp->next)
					switch (vp->value.type) {
					case dtype_string:
						printf("\"%s\" ",
						       vp->value.v.string);
						break;
						
					case dtype_number:
						printf("%ld ",
						       vp->value.v.number);
						break;
						
					default:
						abort();
					}
			} else {
				printf("DEFAULT");
			}
			putchar('\n');

			print_level(level+1);
			printf("ACTION\n");
			print_node_list(pcase->node, level+2);
		}
		break;
	}
	
	case node_type_bin:
		print_level(level);
		print_bin_op(node->v.bin.opcode);
		if (node->v.bin.opcode == bin_match
		    || node->v.bin.opcode == bin_fnmatch) {
			if (node->v.bin.qualifier & QUALIFIER_MX)
				printf(",MX");
			if (node->v.bin.qualifier & QUALIFIER_REGFREE)
				printf(",REGFREE");
		}
		printf("\n");
		print_node(node->v.bin.arg[0], level+1);
		print_node(node->v.bin.arg[1], level+1);
		break;

	case node_type_un:
		print_level(level);
		switch (node->v.un.opcode) {
		case unary_not:
			printf("NOT\n");
			break;
		case unary_minus:
			printf("NEG\n");
			break;
		default:
			abort();
		}
		print_node(node->v.un.arg, level+1);
		break;

	case node_type_next:
		print_level(level);
		printf("next\n");
		break;
		
	case node_type_result:
		if (node->v.ret.code) {
		 	char *s = NULL;
			int expr = 0;
			
			print_level(level);
			if (node->v.ret.message) {
				if (node->v.ret.message->type == node_type_string)
					s = node->v.ret.message->v.string;
				else {
					expr = 1;
					s = "(expression)";
				}
			} 
			dbg_setreply(NULL, node->v.ret.code,
				     node->v.ret.xcode,
				     s);
			if (expr) 
				print_node(node->v.ret.message, level+1);
		}
		print_level(level);
		print_stat(node->v.ret.stat);
		printf("\n");
		break;
		
	case node_type_header:
		print_level(level);
		printf("%s %s: \n", header_command_str(node->v.hdr.opcode),
		       node->v.hdr.name);
		print_node_list(node->v.hdr.value, level+1);
		break;

	case node_type_builtin:
	{
		print_level(level);
		printf("BUILTIN %s\n", node->v.builtin.builtin->name);
		print_node_list(node->v.builtin.args, level+1);
		break;
	}

	case node_type_concat:
		print_level(level);
		printf("CONCAT:\n");
		print_node(node->v.concat.arg[0], level+1);
		print_node(node->v.concat.arg[1], level+1);
		break;

	case node_type_push:
		print_level(level);
		printf("PUSH %p:\n", node->v.val);
		break;

	case node_type_regcomp:
		print_level(level);
		printf("REGCOMP:\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_catch:
	{
		int i;
		
		print_level(level);
		printf("CATCH ");
		for (i = 0; i < mf_status_count; i++)
			if (node->v.catch.exmask & EXMASK(i))
				printf("%s ", mf_status_str(i));
		printf("\n");
		print_node_list(node->v.catch.node, level+1);
		printf("END CATCH\n");
		break;
	}

	case node_type_echo:
		print_level(level);
		printf("ECHO:\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_return:
		print_level(level);
		printf("RETURN:\n");
		print_node(node->v.node, level+1);
		break;
		

	case node_type_call:
		print_level(level);
		printf("CALL %s\n", node->v.call.func->name);
		print_node_list(node->v.call.args, level+1);
		break;

	case node_type_cast:
		print_level(level);
		printf("CAST %s\n", type_to_string(node->v.cast.data_type));
		print_node_list(node->v.cast.node, level+1);
		break;
		
	default:
		abort();
	}		

}	

static void
print_node_list(NODE *node, int level)
{
	for (; node; node = node->next)
		print_node(node, level);
}

int
function_enumerator(void *sym, void *data)
{
	int i;
	struct function *f = sym;
	
	printf("function %s (", f->name);
	for (i = 0; i < f->parmcount; i++) {
		printf("%s", type_to_string(f->parmtype[i]));
		if (i < f->parmcount-1)
			putchar(',');
	}
	putchar(')');
	if (f->rettype != dtype_unspecified)
		printf(" returns %s", type_to_string(f->rettype));
	printf(":\n");
	print_node_list(f->node, 0);
	printf("END function %s\n", f->name);
	return 0;
}
		
void
print_config()
{
	enum smtp_state tag;
	printf("State handlers:\n");
	printf("---------------\n");
	for (tag = smtp_state_first; tag < smtp_state_count; tag++) {
		if (root_node[tag]) {
			printf("%s:\n", state_to_string(tag));
			print_node_list(root_node[tag], 0);
			putchar('\n');
		}
	}
	printf("User functions:\n");
	printf("---------------\n");
	symbol_enumerate(SYM_FUNC, function_enumerator, NULL);
}


static mu_list_t macro_list[smtp_state_count];

void
register_macro(enum smtp_state tag, char *macro)
{
	if (!config_dump_macros)
		return;
	if (!macro_list[tag]) {
		mu_list_create(&macro_list[tag]);
		mu_list_set_comparator(macro_list[tag], compare_string);
	}
	if (mu_list_locate(macro_list[tag], macro, NULL)) 
		mu_list_append(macro_list[tag], macro);
}

static int
print_macro(void *item, void *data)
{
	int *p = data;
	if (*p) {
		printf(" ");
		*p = 0;
	} else
		printf(", ");
	printf("%s", item);
	return 0;
}


void
print_used_macros()
{
	enum smtp_state tag;
	
	for (tag = smtp_state_first; tag < smtp_state_count; tag++) {
		if (macro_list[tag]) {
			int n = 1;
			printf("%s", state_to_string(tag));
			mu_list_do(macro_list[tag], print_macro, &n);
			printf("\n");
		}
	}
}


/* Code generation */
int errors;

#define __code_cat3__(a,b,c) a ## b ## c

#define CODE_BINARY(op, node) do {                                            \
	switch (node_type(node->v.bin.arg[0])) {                              \
	case dtype_number:                                                    \
		code_instr(__code_cat3__(instr_,op,n));                       \
		break;                                                        \
	case dtype_string:                                                    \
		code_instr(__code_cat3__(instr_,op,s));                       \
		break;                                                        \
	default:                                                              \
		parse_error_locus(&node->locus,                               \
				"Invalid argument type in binary operation"); \
		break;                                                        \
	}                                                                     \
} while (0)

int
code_cast(struct locus *locus, data_type_t fromtype, data_type_t totype)
{
	if (fromtype == totype) {
		if (totype == dtype_string)
			code_instr(instr_svalidate);
		return 0;
	}
	
	switch (fromtype) {
	case dtype_unspecified:
		parse_error_locus(locus,
				  "Expression evaluates to unspecified data type");
		errors = 1;
		return 1;

	case dtype_string:
		code_instr(instr_svalidate);
		code_instr(instr_ston);
		break;
		
	case dtype_number:
		code_instr(instr_ntos);
		break;
	}
	return 0;
}

static void traverse_tree(NODE *node);
static void code_node(NODE *node);

static void
jump_fixup(prog_counter_t pos, prog_counter_t endpos)
{
	while (pos) {
		prog_counter_t next = (prog_counter_t)code_peek(pos);
		code_put(pos, (void*)(endpos - pos - 1));
		pos = next;
	}
}

/* The following code is generated for switch statements:
   
	popreg      ; Pop the result of the previous instruction into the reg
	xlat        ; Look up in the table and replace reg with the new value
	            ; If the switch selector is of string type, xlats is
		    ; coded instead
	N           ; Number of elements in the xlat table
	key1        ; First key 
	off1        ; Corresponding jump offset, relative to L0
	key2        ; Second key
	off2        ; Corresponding jump offset, relative to L0 
	.
	.
	.
	keyN
	offN
	bnz L1      ; If xlat failed, jump to the default case
L0:	jreg        ; Jump to the selected branch 
L1:	
	...         ; Default case
L0+off1:
        ...         ; First branch
	jmp L2
L0+off2:
        ...         ; Second branch
	jmp L2
	.
	.
	.
L0+offN:
        ...         ; Nth branch
L2:	
*/
static void
code_switch_branches(NODE *node, data_type_t type)
{
	prog_counter_t start, refpos, jmppos;
	struct case_stmt *pcase;
	size_t tabsize = 0;

	/* Compute the table size and convert all key values
	   to type */
	for (pcase = node->v.switch_stmt.cases;
	     pcase;
	     pcase = pcase->next) {
		struct valist *vp;
		long v;
		char *p;

		for (vp = pcase->valist; vp; vp = vp->next) {
			tabsize++;
			if (vp->value.type != type) {
				char buf[NUMERIC_BUFSIZE_BOUND];

				/* FIXME: The following code is very crude */
				switch (type) {
				case dtype_number:
					v = strtol(vp->value.v.string, &p, 0);
					if (*p) {
						parse_error_locus(&pcase->locus,
						"cannot convert %s to number",
							vp->value.v.string);
						errors = 1;
						return;
					}
					vp->value.v.number = v;
					break;

				case dtype_string:
					snprintf(buf, sizeof buf, "%ld",
						 vp->value.v.number);
					vp->value.v.string = strdup(buf);
					break;

				default:
					abort();
				}
			}
		}
	}

	code_instr(instr_popreg);
	code_instr(type == dtype_number ? instr_xlat : instr_xlats);
	start =	code_reserve(2*tabsize+1);
	code_instr(instr_bnz);
	code_immediate((void*)1);
	refpos = code_instr(instr_jreg);
		
	/* Generate code for the branches */
	jmppos = 0;
	code_put(start, (void*)tabsize);
	start++;
	for (pcase = node->v.switch_stmt.cases;
	     pcase;
	     pcase = pcase->next) {
		struct valist *vp;
		prog_counter_t pos;
		
		pos = code_get_counter() - refpos;
		traverse_tree(pcase->node);
		if (pcase->next) {
			code_instr(instr_jmp);
			jmppos = code_immediate((void*)jmppos);
		}
		for (vp = pcase->valist; vp; vp = vp->next) {
			code_put(start, (void*)vp->value.v.string);
			code_put(start+1, (void*)pos);
			start += 2;
		}
	}

	/* Fix up jump offsets */
	jump_fixup(jmppos, code_get_counter());
}
	
static void
code_switch(NODE *node)
{
	code_node(node->v.switch_stmt.node);
	code_switch_branches(node, node_type(node->v.switch_stmt.node));
}
		
#define LOCUS_EQ(a,b) \
 (strcmp((a)->file, (b)->file) == 0 && (a)->line == (b)->line)

static void
code_node(NODE *node)
{
	prog_counter_t pos1, pos2, endpos;
	static struct locus *old_locus;

	if (!node) {
		errors++;
		return;
	}
#define MARK_LOCUS()                                                 \
	do if (!old_locus || !LOCUS_EQ(old_locus, &node->locus)) {   \
		old_locus = &node->locus;                            \
		code_instr(instr_locus);                             \
		code_immediate(node->locus.file);                    \
		code_immediate((void*)node->locus.line);             \
	} while (0)

	switch (node->type) {
	case node_type_string:
		MARK_LOCUS();
		code_instr(instr_push_immediate);
		code_immediate(node->v.string);
		break;

	case node_type_number:
		MARK_LOCUS();
		code_instr(instr_push_immediate);
		code_immediate((void*)node->v.number);
		break;
		
	case node_type_symbol:
		MARK_LOCUS();
		code_instr(instr_symbol);
		code_immediate(node->v.string);
		break;

	case node_type_variable:
		MARK_LOCUS();
		code_instr(instr_variable);
		code_immediate((void*)node->v.variable->off);
		break;

	case node_type_backref:
		MARK_LOCUS();
		code_instr(instr_backref);
		code_immediate((void*)node->v.number);
		break;
		
	case node_type_arg:
		MARK_LOCUS();
		code_instr(instr_arg);
		code_immediate((void*)node->v.arg.number);
		break;

	case node_type_auto:
		MARK_LOCUS();
		code_instr(instr_auto);
		code_immediate((void*)node->v.arg.number);
		break;
		
	case node_type_asgn:
		code_node(node->v.asgn.node);
		node->v.variable->type = node_type(node->v.asgn.node);
		code_instr(instr_asgn);
		code_immediate((void*)node->v.variable->storage_class);
		code_immediate((void*)node->v.variable->off);
		break;
			
	case node_type_if:
		code_node(node->v.cond.cond);
		MARK_LOCUS();
		code_instr(instr_bz);
		pos1 = code_immediate(NULL);
		traverse_tree(node->v.cond.if_true);
		if (node->v.cond.if_false) {
			code_instr(instr_jmp);
			pos2 = code_immediate(NULL);
			traverse_tree(node->v.cond.if_false);
			endpos = code_get_counter ();
			code_put(pos1, (void *)(pos2 - pos1));
			code_put(pos2, (void *)(endpos - pos2 - 1));
		} else 
			code_put(pos1, (void *)(code_get_counter () - pos1 - 1));
		break;

	case node_type_bin:
		code_node(node->v.bin.arg[0]);

		switch (node->v.bin.opcode) {
		case bin_and:
			MARK_LOCUS();
			/* cond1                        
			   if not true goto X
			   cond2
			   if true goto Y
			X: push 0
			   goto Z
			Y: push 1
                        Z: */
			code_instr(instr_bz);
			pos1 = code_immediate(NULL);
			code_node(node->v.bin.arg[1]);
			code_instr(instr_bnz);
			pos2 = code_immediate((void *)4);
			code_instr(instr_push_immediate);
			code_immediate((void *)0);
			code_instr(instr_jmp);
			code_immediate((void *)2);
			code_instr(instr_push_immediate);
			code_immediate((void*)1);
			code_put(pos1, (void *)(pos2 - pos1));
			break;
			
		case bin_or:
			MARK_LOCUS();
			/* cond1                        
			   if true goto X
			   cond2
			   if not true goto Y
			X: push 1
			   goto Z
			Y: push 0
                        Z: */

			code_instr(instr_bnz);
			pos1 = code_immediate(NULL);
			code_node(node->v.bin.arg[1]);
			code_instr(instr_bz);
			pos2 = code_immediate((void *)4);
			code_instr(instr_push_immediate);
			code_immediate((void *)1);
			code_instr(instr_jmp);
			code_immediate((void *)2);
			code_instr(instr_push_immediate);
			code_immediate((void *)0);
			code_put(pos1, (void *)(pos2 - pos1));
			break;

		case bin_eq:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(eq, node);
			break;
			
		case bin_ne:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(ne, node);
			break;

		case bin_lt:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(lt, node);
			break;
			
		case bin_le:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(le, node);
			break;

		case bin_gt:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(gt, node);
			break;

		case bin_ge:
			code_node(node->v.bin.arg[1]);
			CODE_BINARY(ge, node);
			break;
			
		case bin_match:
			code_node(node->v.bin.arg[1]);
			code_instr(instr_push_immediate);
			code_immediate((void*) (node->v.bin.qualifier &
						 QUALIFIER_REGFREE));
			MARK_LOCUS();
			if (node->v.bin.qualifier & QUALIFIER_MX)
				code_instr(instr_regex_mx);
			else
				code_instr(instr_regex);
			break;

		case bin_fnmatch:
			code_node(node->v.bin.arg[1]);
			MARK_LOCUS();
			if (node->v.bin.qualifier & QUALIFIER_MX)
				code_instr(instr_fnmatch_mx);
			else
				code_instr(instr_fnmatch);
			break;

		case bin_add:
			code_node(node->v.bin.arg[1]);
			MARK_LOCUS();
			code_instr(instr_add);
			break;
			
		case bin_sub:
			code_node(node->v.bin.arg[1]);
			MARK_LOCUS();
			code_instr(instr_sub);
			break;
			
		case bin_mul:
			code_node(node->v.bin.arg[1]);
			MARK_LOCUS();
			code_instr(instr_mul);
			break;
			
		case bin_div:
			code_node(node->v.bin.arg[1]);
			MARK_LOCUS();
			code_instr(instr_div);
			break;
			
		default:
			break;
		}
		break;

	case node_type_regcomp:
		code_node(node->v.node);
		code_instr(instr_regcomp);
		break;

	case node_type_push:
		code_instr(instr_push_immediate);
		code_immediate(node->v.val);
		break;
		
	case node_type_un:
		code_node(node->v.un.arg);
		MARK_LOCUS();
		switch (node->v.un.opcode) {
		case unary_not:
			code_instr(instr_not);
			break;
			
		case unary_minus:
			code_instr(instr_neg);
			break;

		default:
			abort();
		}
		break;

	case node_type_next:
		MARK_LOCUS();
		code_instr(instr_next);
		break;

	case node_type_result:
		if (node->v.ret.message)
			code_node(node->v.ret.message);
		else {
			code_instr(instr_push_immediate);
			code_immediate(NULL);
		}
		MARK_LOCUS();
		code_instr(instr_result);
		code_immediate((void*)node->v.ret.stat);
		code_immediate(node->v.ret.code);
		code_immediate(node->v.ret.xcode);
		code_instr(NULL);
		break;

	case node_type_header:
		MARK_LOCUS();
		code_node(node->v.hdr.value);
		code_instr(instr_header);
		code_immediate((void*)node->v.hdr.opcode);
		code_immediate(node->v.hdr.name);
		break;

	case node_type_builtin:
	{
		NODE *p;
		for (p = node->v.builtin.args; p; p = p->next) 
			code_node(p);
		
		MARK_LOCUS();
		code_instr(instr_builtin);
		code_immediate(node->v.builtin.builtin->name);
		code_immediate(node->v.builtin.builtin->handler);
		break;
	}
	
	case node_type_call:
	{
		NODE *p;

		for (p = node->v.call.args; p; p = p->next) 
			code_node(p);
		
		MARK_LOCUS();
		code_instr(instr_funcall);
		code_immediate(node->v.call.func->name);
		code_immediate((void*)node->v.call.func->entry);
		code_instr(instr_adjust);
		code_immediate((void*)node->v.call.func->parmcount);
		if (node->v.call.func->rettype != dtype_unspecified)
			code_instr(instr_pushreg);
		break;
	}
	
	case node_type_concat:
		code_node(node->v.concat.arg[0]);
		code_node(node->v.concat.arg[1]);
		code_instr(instr_concat);
		break;

	case node_type_catch:
	{
		int old_tie_in;
		prog_counter_t ctr;
		
		MARK_LOCUS();
		code_instr(instr_catch);
		pos1 = code_immediate(NULL);
		code_immediate((void*)node->v.catch.count);
		code_immediate((void*)node->v.catch.exmask);
		old_tie_in = stie_in;
		stie_in = synt_catch;
		ctr = jump_pc;
		jump_pc = 0;

		traverse_tree(node->v.catch.node);
		jump_fixup(jump_pc, code_get_counter());
		
		jump_pc = ctr;
		stie_in = old_tie_in;

		code_instr(instr_retcatch);
		if (stie_in == synt_function) {
			code_instr(instr_adjust);
			code_immediate((void*)1);
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
		} else {
			code_instr(instr_push_immediate);
                        code_immediate(NULL);
			code_instr(instr_result);
			code_immediate(SMFIS_CONTINUE);
			code_immediate(NULL);
			code_immediate(NULL);
			code_immediate(NULL);
		}

		endpos = code_get_counter ();
		code_put(pos1, (void *)(endpos - pos1));

		break;
	}

	case node_type_echo:
		code_node(node->v.node);
		MARK_LOCUS();
		code_instr(instr_echo);
		break;

	case node_type_return:
		if (func->rettype == dtype_unspecified) {
			MARK_LOCUS();
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
		} else {
			code_node(node->v.node);
			MARK_LOCUS();
			code_instr(instr_popreg);
			code_instr(instr_jmp);
			jump_pc = code_immediate((void*)jump_pc);
		}
		break;

	case node_type_switch:
		code_switch(node);
		break;

	case node_type_cast:
		code_node(node->v.cast.node);
		code_cast(&node->v.cast.node->locus,
			  node_type(node->v.cast.node),
			  node->v.cast.data_type);
		break;
		
	default:
		abort();
	}
}

static void
traverse_tree(NODE *node)
{
	for (; node; node = node->next)
		code_node(node);
}

static void optimize(NODE *node);

static void
optimize_node(NODE *node)
{
	int i;
	NODE *p;
	
	switch (node->type) {
	case node_type_bin:
		optimize(node->v.bin.arg[0]);
		optimize(node->v.bin.arg[1]);
		if (node->v.bin.opcode == bin_match) {
			if (node->v.bin.arg[1]->type == node_type_string) {
				int rc;
				regex_t *regex;
				NODE *p = alloc_node(node_type_push,
						     &node->locus);

				regex = emalloc(sizeof *regex);
				rc = regcomp(regex,
					     node->v.bin.arg[1]->v.string,
					     regex_flags);
				if (rc) {
					char errbuf[512];
					regerror(rc,
						 regex, errbuf,
						 sizeof(errbuf));
					parse_error_locus(&node->locus,
						   "Cannot compile regex: %s",
							  errbuf);
					error_count++;
					free(regex);
					break;
				}
				p->v.val = regex;
				node->v.bin.arg[1] = p;
			} else {
				NODE *p = alloc_node(node_type_regcomp,
						     &node->locus);
				p->v.node = node->v.bin.arg[1];
				node->v.bin.arg[1] = p;
				node->v.bin.qualifier |= QUALIFIER_REGFREE;
			}
		}
		break;
		
	case node_type_if:
		optimize(node->v.cond.cond);
		optimize(node->v.cond.if_true);
		optimize(node->v.cond.if_false);
		break;

	case node_type_un:
		optimize(node->v.un.arg);
		break;

	case node_type_asgn:
		optimize(node->v.asgn.node);
		break;

	case node_type_result:
		optimize(node->v.ret.message);
		break;

	case node_type_builtin:
		for (i = 0, p = node->v.builtin.args; p; i++, p = p->next) 
			optimize(p);
		if (strcmp(node->v.builtin.builtin->name, "interval") == 0) {
			if (node->v.builtin.args->type ==
			    node_type_string) {
				time_t t;
				char *endp;
				
				if (parse_time_interval(
					    node->v.builtin.args->v.string,
					    &t, &endp)) {
					parse_error_locus(&node->locus,
					"unrecognized time format (near `%s')",
							  endp);
					error_count++;
					break;
				}
				/* Replace this node */
				node->type = node_type_number;
				node->v.number = t;
			}
		}
		break;

	case node_type_concat:
		optimize(node->v.concat.arg[0]);
		optimize(node->v.concat.arg[1]);
		break;

	case node_type_catch:
		optimize(node->v.catch.node);
		break;

	case node_type_echo:
	case node_type_return:
		optimize(node->v.node);
		break;

	case node_type_switch:
	{
		struct case_stmt *pcase;
		
		optimize(node->v.switch_stmt.node);
		for (pcase = node->v.switch_stmt.cases;
		     pcase; pcase = pcase->next) 
			optimize(pcase->node);
		break;
	}

	case node_type_header:
		optimize(node->v.hdr.value);
		break;

	case node_type_cast:
		optimize(node->v.cast.node);
		break;
		
	default:
		break;
	}
}

static void
optimize(NODE *node)
{
	for (; node; node = node->next)
		optimize_node(node);
}

static int
codegen(prog_counter_t *pc, NODE *node)
{
	*pc = code_get_counter();
	errors = 0;
	jump_pc = 0;
	optimize(node);
	traverse_tree(node);
	code_instr(NULL);
	return errors;
}



#define skip_ws(p) while (*(p) && isspace(*(p))) (p)++;
			  
static char *
getword(char **p, char **buf)
{
	int len;
	
	skip_ws(*p);
	if (!**p)
		return NULL;
	for (len = 0; (*p)[len] && !isspace((*p)[len]); len++)
		;
	*buf = malloc(len+1);
	if (*buf) {
		memcpy(*buf, *p, len);
		(*buf)[len] = 0;
	}
	*p += len;
	return *buf;
}

enum regex_mode { regex_enable, regex_disable, regex_set };

static void
pragma_regex(char *text)
{
	char *p, *buf;
	int bit;
	enum regex_mode mode = regex_set;
	
	while (p = getword(&text, &buf)) {
		switch (p[0]) {
		case '+':
			mode = regex_enable;
			p++;
			break;

		case '-':
			mode = regex_disable;
			p++;
			break;

		case '=':
			mode = regex_set;
			p++;
			break;
		}

		if (strcmp (p, "extended") == 0)
			bit = REG_EXTENDED;
		else if (strcmp (p, "icase") == 0)
			bit = REG_ICASE;
		else if (strcmp (p, "newline") == 0)
			bit = REG_NEWLINE;
		else {
			parse_error("Unknown regexp flag: %s", p);
			free(buf);
			return;
		}

		switch (mode) {
		case regex_disable:
			regex_flags &= ~bit;
			break;
		case regex_enable:
			regex_flags |= bit;
			break;
		case regex_set:
			regex_flags = bit;
			break;
		}
		free(buf);
	}
}

static void
pragma_option(char *text)
{
	char *name;
	char *value;
	char *p;
	int len;
	
	if (!getword(&text, &name)) {
		parse_error("Invalid pragma: expected option name");
		return;
	}

#define EXPIRE_SUFFIX 	"expire-interval"
#define EXPIRE_SUFFIX_LEN (sizeof(EXPIRE_SUFFIX)-1)

#define TIMEOUT_SUFFIX  "timeout"
#define TIMEOUT_SUFFIX_LEN (sizeof(TIMEOUT_SUFFIX)-1)

	if (strcmp(name, "mailfrom") == 0
	    || (strlen(name) >= EXPIRE_SUFFIX_LEN
		&& strcmp(name + strlen(name) - EXPIRE_SUFFIX_LEN,
			  EXPIRE_SUFFIX) == 0)
	    || (strlen(name) >= TIMEOUT_SUFFIX_LEN
		&& strcmp(name + strlen(name) - TIMEOUT_SUFFIX_LEN,
			  TIMEOUT_SUFFIX) == 0)) {
		/* Special handling for expire and timeout intervals */
		value = strdup(text);
		text += strlen(text);
	} else if (!getword(&text, &value)) {
		parse_error("Invalid pragma: expected option value");
		free(name);
		return;
	}

	skip_ws(text);
	if (*text) {
		parse_error("Invalid pragma: junk after the arguments");
		/* Try to handle it anyway */
	}

	p = value;
	skip_ws(p);
	len = strlen(p);
	if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
		p[len-1] = 0;
		p++;
	}
		
	if (set_option(name, p, 0)) {
		if (errno == ENOENT)
			parse_error("Unknown pragma option");
		else
			parse_error("Invalid pragma");
	}
	
	free(name);
	free(value);
}

static void
pragma_stacksize(char *text)
{
	char *p;
	stack_size = strtoul(text, &p, 0);
	if (*p) {
		for (; *p; p++) 
			if (!(isascii(*p) && isspace(*p))) {
				parse_error("Invalid pragma: junk after stack size");
				return;
			}
	}
}

static int
get_interval(char *text, time_t *pinterval)
{
	char *endp;
	time_t interval;

	while (*text && isspace(*text))
		text++;
	if (!*text) {
		parse_error("Invalid pragma: unexpected end of line");
		return 1;
	}
	if (parse_time_interval(text, &interval, &endp)) {
		parse_error("Invalid pragma: unrecognized time format "
			    "(near `%s')",
			    endp);
		return 1;
	}
	*pinterval = interval;
	return 0;
}

/* #pragma database FMTNAME file FILENAME
   #pragma database FMTNAME expire-interval INTERVAL
   #pragma database cache positive-expire-interval INTERVAL
   #pragma database cache negative-expire-interval INTERVAL
*/
static void
pragma_database(char *text)
{
	char *fmtname;
	char *kw;
	struct db_format *fmt;
	
	if (!getword(&text, &fmtname)) {
		parse_error("Invalid pragma: expected database name");
		return;
	}
	if ((fmt = db_format_lookup(fmtname)) == NULL) {
		parse_error("unknown database format: %s", fmtname);
		return;
	}
	if (!getword(&text, &kw)) {
		parse_error("Invalid pragma: expected keyword");
		return;
	}
	if (strcmp(kw, "file") == 0) {
		char *value;
		char *p;
		int len;
		
		if (!getword(&text, &value)) {
			parse_error("Invalid pragma: expected file name");
			return;
		}
		p = value;
		len = strlen(p);
		if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
			p[len-1] = 0;
			p++;
		}
		fmt->dbname = strdup(p);
	} else if (strcmp(kw, "expire-interval") == 0) {
		get_interval(text, &fmt->expire_interval);
	} else if (strcmp(kw, "positive-expire-interval") == 0) {
		if (fmt != cache_format) {
			parse_error("positive-expire-interval is valid only "
				    "for cache database");
			return;
		}
		get_interval(text, &fmt->expire_interval);
	} else if (strcmp(kw, "negative-expire-interval") == 0) {
		if (fmt != cache_format) {
			parse_error("negative-expire-interval is valid only "
				    "for cache database");
			return;
		}
		get_interval(text, &negative_expire_interval);
	} else {
		parse_error("Invalid pragma: unrecognized keyword: %s", kw);
		return;
	}
}

void
parse_pragma(char *text)
{
	char *buf;

	while (*text != '#')
		text++;
	++text;
	skip_ws(text);
	text += 6; /* "pragma" */

	if (!getword(&text, &buf))
		parse_error("Empty pragma");
	else if (strcmp(buf, "regex") == 0)
		pragma_regex(text);
	else if (strcmp(buf, "database") == 0)
		pragma_database(text);
	else if (strcmp(buf, "option") == 0)
		pragma_option(text);
	else if (strcmp(buf, "stacksize") == 0)
		pragma_stacksize(text);
	else
		parse_error("Unknown pragma");
	free(buf);
}


/* Test run */
struct sfsistat_tab {
	char *name;
	sfsistat stat;
} sfsistat_tab[] = {
	{ "accept", SMFIS_ACCEPT },
	{ "continue", SMFIS_CONTINUE },
	{ "discard", SMFIS_DISCARD },
	{ "reject", SMFIS_REJECT },
	{ "tempfail", SMFIS_TEMPFAIL },
	{ NULL }
};

const char *
sfsistat_str(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) 
			return p->name;
	return NULL;
}

void
print_stat(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) {
			printf("%s", p->name);
			return;
		}
	printf("%d", stat);
}

const char *
header_command_str(enum header_opcode opcode)
{
	switch (opcode) {
	case header_add:
		return "ADD HEADER ";
		
	case header_replace:
		return "REPLACE HEADER ";
		break;

	case header_delete:
		return "DELETE HEADER ";
		break;
	}
	return "UNKNOWN HEADER COMMAND ";
}

static int
dbg_setreply(void *data, char *code, char *xcode, char *message)
{
	if (code) {
		printf("SET REPLY %s", code);
		if (xcode)
			printf(" %s", xcode);
		if (message)
			printf(" %s", message);
		printf("\n");
	}
	return 0;
}

static void
dbg_setheader(void *data, struct old_header_node *hdr)
{
	printf("%s %s: %s\n", header_command_str(hdr->opcode), hdr->name,
	       hdr->value);
}

void
mailfromd_test(int argc, char **argv)
{
	int i, rc;
	mu_list_t dict = NULL;
	eval_environ_t env;
	char *p, *end;
	long n;
	sfsistat status;
	char *args[9] = {0,0,0,0,0,0,0,0,0};
		
	dict_init(&dict);
	env = create_environment(NULL,
				 dict_getsym, dbg_setreply, dbg_setheader,
				 dict);
	env_init(env);
	for (i = 0; i < argc; i++) {
		if (p = strchr(argv[i], '=')) {
			char *ident = argv[i];
			*p++ = 0;
			if (*ident == '%') 
				env_set_variable(env, ident+1, p);
			else if (isdigit(*ident) && *ident != 0
				 && ident[1] == 0) 
				args[*ident - '0' - 1] = p;
			else 
				dict_install(dict, argv[i], p);
		}
	}

	for (i = state_parms[test_state].cnt; i--; ) {
		switch (state_parms[test_state].types[i]) {
		case dtype_string:
			env_push_string(env, args[i] ? args[i] : "");
			break;
		case dtype_number:
			n = strtol(p, &end, 0);
			if (*end) 
				mu_error("$%d is not a number", i+1);
			env_push_number(env, n);
			break;
		default:
			abort();
		}
	}
	env_make_frame(env);
	rc = xeval(env, test_state);
	env_leave_frame(env, state_parms[test_state].cnt);
	status = environment_get_status(env);
	printf("State %s: ", state_to_string(test_state));
	print_stat(status);
	printf("\n");
	destroy_environment(env);
}

void
set_poll_arg(struct poll_data *poll, int kw, NODE *expr)
{
	switch (kw) {
	case FOR:
		poll->email = expr;
		break;
		
	case HOST:
		poll->client_addr = expr;
		break;
		
	case AS:
		poll->mailfrom = expr;
		break;
		
	case FROM:
		poll->ehlo = expr;
		break;
		
	default:
		abort();
	}
}
		
static int
time_multiplier(const char *str, unsigned *m, unsigned *plen)
{
	static struct timetab {
		char *name;
		unsigned mul;
	} tab[] = {
		{ "seconds", 1 },
		{ "minutes", 60 },
		{ "hours", 60*60 },
		{ "days",  24*60*60 },
		{ "weeks", 7*24*60*60 },
		{ "months", 31*7*24*60*60 },
		{ NULL }
	};
	struct timetab *p;
	int slen;

	for (slen = 0; str[slen]; slen++)
		if (isspace(str[slen]))
			break;

	for (p = tab; p->name; p++) {
		if (p->name[0] == tolower(str[0])) {
			int nlen = strlen(p->name);

			if (nlen > slen)
				nlen = slen;
			
			if (strncasecmp(p->name, str, nlen) == 0) {
				*m = p->mul;
				if (plen)
					*plen = nlen;
				return 0;
			}
		}
	}
	return 1;
}

int
parse_time_interval(char *str, time_t *pint, char **endp)
{
	int rc = 0;
	time_t interval = 0;
	
	while (*str) {
		char *p;
		unsigned long n;
		unsigned mul, len;

		while (*str && isspace(*str))
			str++;

		if (!isdigit(*str) && time_multiplier(str, &mul, &len) == 0) {
			n = 1;
			str += len;
		} else {
			n = strtoul(str, &p, 10);
			if (*p && !isspace(*p)) {
				str = p;
				rc = 1;
				break;
			}

			while (*p && isspace(*p))
				p++;

			str = p;
			if (*str) {
				if (rc = time_multiplier(str, &mul, &len))
					break;
				str += len;
			} else
				mul = 1;
		}
		interval += n*mul;
	}

	if (rc && endp)
		*endp = str;
	*pint = interval;
	return rc;
}

int
convert_rate(const char *arg, double *rate)
{
	double count;
	char *p;

	count = strtod(arg, &p);
	if (*p) {
		time_t div;
		char *endp;

		while (*p && isspace(*p))
			p++;
		if (isalpha(*p)) {
			if (strcmp(p, "per") == 0 && isspace(p[3]))
				p += 3;
		} else if (ispunct(*p))
			p++;

		if (parse_time_interval(p, &div, &endp)) {
			mu_error("unrecognized time format (near `%s')",
				 endp);
			return 1;
		}
		count /= div;
	}
	*rate = count;
	return 0;
}
		
static struct tagtable {
	char *name;
	enum smtp_state tag;
} tagtable[] = {
	{ "connect", smtp_state_connect },
	{ "helo", smtp_state_helo },  
	{ "envfrom", smtp_state_envfrom }, 
	{ "envrcpt", smtp_state_envrcpt }, 
	{ "header", smtp_state_header }, 
	{ "eoh", smtp_state_eoh }, 
	{ "body", smtp_state_body }, 
	{ "eom", smtp_state_eom },
};

enum smtp_state
string_to_state(char *name)
{
	struct tagtable *p;

	for (p = tagtable; p < tagtable + sizeof tagtable/sizeof tagtable[0];
	     p++)
		if (strcasecmp (p->name, name) == 0)
			return p->tag;

	return smtp_state_none;
}

const char *
state_to_string(enum smtp_state state)
{
	if (state-1 < sizeof tagtable/sizeof tagtable[0])
		return tagtable[state-1].name;
	abort();
}


struct variable *
builtin_variable_install(const char *name, data_type_t type)
{
	struct variable *var = variable_install(name);
	var->type = type;
	var->off = variable_count++;
	return var;
}

static NODE *
_reverse(NODE *list, NODE **root)
{
	NODE *next;

	if (list->next == NULL) {
		*root = list;
		return list;
	}
	next = _reverse(list->next, root);
	next->next = list;
	list->next = NULL;
	return list;
}		

NODE *
reverse(NODE *in)
{
	NODE *root;
	if (!in)
		return in;
	_reverse(in, &root);
	return root;
}


static NODE *
create_on_node(NODE *sel, struct case_stmt *cases)
{
	struct case_stmt *cur;
	unsigned mask = 0;
	char nbuf[NUMERIC_BUFSIZE_BOUND];
	struct function *fp;
	const char *base_name;
	char *fname;
	size_t size;
	int count = 0;
	int argc;
	NODE *args;
	data_type_t *ptypes, rettype;
	NODE *call_node, *retnode;
		     
	/* Create a list of exceptions to catch */
	for (cur = cases; cur; cur = cur->next) {
		struct valist *vp;
		for (vp = cur->valist; vp; vp = vp->next) {
			mask |= EXMASK(vp->value.v.number);
			count++;
		}
	}

	/* Check if we already have a wrapper function */
	snprintf(nbuf, sizeof nbuf, "%u", mask);
	switch (sel->type) {
	case node_type_builtin:
		base_name = sel->v.builtin.builtin->name;
		argc = sel->v.builtin.builtin->parmcount;
		args = reverse(sel->v.builtin.args);
		ptypes = sel->v.builtin.builtin->parmtype;
		rettype = sel->v.builtin.builtin->rettype;
		break;
	case node_type_call:
		base_name = sel->v.call.func->name;
		argc = sel->v.call.func->parmcount;
		args = sel->v.call.args;
		ptypes = sel->v.call.func->parmtype;
		rettype = sel->v.call.func->rettype;
		break;
	default:
		abort();
	}

	size = 2 + strlen(base_name) + 1 + strlen(nbuf) + 1;
	fname = emalloc(size);
	strcpy(fname, "$");
	strcat(fname, base_name);
	strcat(fname, "_");
	strcat(fname, nbuf);
	strcat(fname, "$");
	
	fp = function_lookup(fname);
	if (!fp) {
		/* Build and register the function */
		NODE *np, *catch_node;
		NODE *head, *tail;
		prog_counter_t pc;
		int i;
		struct function *save_func = func;
		int save_stie_in = stie_in;
		prog_counter_t save_jump_pc = jump_pc;
		
		/* Create the catch statement */
		np = alloc_node(node_type_catch, get_locus());
		np->v.catch.count = count;
		np->v.catch.exmask = 0;
		for (cur = cases; cur; cur = cur->next) {
			struct valist *vp;
			for (i = 0, vp = cur->valist;
			     vp; vp = vp->next, i++)
				np->v.catch.exmask |= EXMASK(vp->value.v.number);
		}
		
		catch_node = np;
		
		np = alloc_node(node_type_return, get_locus());
		np->v.node = alloc_node(node_type_arg, get_locus());
		np->v.node->v.arg.number = 1;
		np->v.node->v.arg.data_type = PARMTYPE(1);
		catch_node->v.catch.node = np;

		/* Build call arguments */
		head = tail = NULL;
		for (i = 1; i <= argc; i++) {
			np = alloc_node(node_type_arg, get_locus());
			/* FIXME: Verify if this is always correct */
			np->v.arg.data_type = ptypes[i-1];
			np->v.arg.number = i;
			if (!head)
				head = tail = np;
			else {
				tail->next = np;
				tail = np;
			}
		}
				     
		np = alloc_node(node_type_return, get_locus());
		np->v.node = sel; /* FIXME: create a copy */
		switch (np->v.node->type) {
		case node_type_builtin:
			np->v.node->v.builtin.args = head;
			break;
		case node_type_call:
			np->v.node->v.call.args = head;
			break;
		default:
			abort();
		}
		
		catch_node->next = np;
		
		fp = function_install(fname, argc, ptypes,
				      rettype,
				      get_locus());
		fp->exmask = mask;
		fp->node = catch_node;
		fp->entry = code_get_counter();
		
		/* Entry code */
		code_instr(instr_saveex);
		code_immediate((void*)fp->exmask);
		
		func = fp;
		stie_in = synt_function;
		jump_pc = 0;
		
		if (codegen(&pc, fp->node))
			error_count++;
		else {
			jump_fixup(jump_pc, code_get_counter());
			
			/* Exit code */
			code_instr(instr_restex);
			code_instr(instr_return);
		}
		func = save_func;
		stie_in = save_stie_in;
		jump_pc = save_jump_pc;
	}
	free(fname);
	
	call_node = alloc_node(node_type_call, get_locus());
	call_node->v.call.func = fp;
	call_node->v.call.args = args;
	
	retnode = alloc_node(node_type_switch, get_locus());
	retnode->v.switch_stmt.node = call_node;
	retnode->v.switch_stmt.cases = cases;

	return retnode;
}

NODE *
function_call(struct function *function, size_t count, NODE *subtree)
{
	NODE *np = NULL;
	if (count < function->parmcount) {
		parse_error("Too few arguments in call to `%s'",
			    function->name);
	} else if (count > function->parmcount) {
		parse_error("Too many arguments in call to `%s'",
			    function->name);
	} else {
		np = alloc_node(node_type_call, get_locus());
		np->v.call.func = function;
		np->v.call.args = reverse(cast_arg_list(subtree,
							function->parmtype));
	}
	return np;
}	

data_type_t
node_type(NODE *node)
{
	switch (node->type) {
	case node_type_string:
	case node_type_symbol:
		return dtype_string;

	case node_type_number:
		return dtype_number;
		
	case node_type_if:
		return dtype_unspecified;
		
	case node_type_bin:
		return dtype_number;
		
	case node_type_un:
		return dtype_number;
		
	case node_type_builtin:
		return node->v.builtin.builtin->rettype;
		
	case node_type_concat:
		return dtype_string;
		
	case node_type_variable:
		return node->v.variable->type;
		
	case node_type_arg:
	case node_type_auto:
		return node->v.arg.data_type;

	case node_type_call:
		return node->v.call.func->rettype;
		
	case node_type_return:
		if (node->v.node)
			return node_type(node->v.node);
		break;

	case node_type_backref:
		return dtype_string;

	case node_type_cast:
		return node->v.cast.data_type;
		
	case node_type_next:
	case node_type_result:
	case node_type_header:
	case node_type_asgn:
	case node_type_push:
	case node_type_regcomp:
	case node_type_catch:
	case node_type_echo:
	case node_type_switch:
		break;
	}
	return dtype_unspecified;
}

NODE *
cast_to(data_type_t type, NODE *node)
{
	NODE *np;
	data_type_t ntype = node_type(node);
	
	switch (ntype) {
	case dtype_string:
		break;
		
	case dtype_number:
		if (type == ntype)
			return node;
		break;
		
	case dtype_unspecified:
		parse_error("cannot convert %s to %s", type_to_string(ntype),
			    type_to_string(type));
		error_count++;
		return NULL;

	default:
		abort();
	}
	np = alloc_node(node_type_cast, get_locus());
	np->v.cast.data_type = type;
	np->v.cast.node = node;
	node->next = NULL;
	return np;
}

NODE *
cast_arg_list(NODE *args, data_type_t *parmtype)
{
	NODE *head = NULL, *tail = NULL;
	unsigned n = 1;
	
	while (args) {
		NODE *next = args->next;
		NODE *p = cast_to(*parmtype, args);

		if (head)
			tail->next = p;
		else
			head = p;
		tail = p;
		args = next;
		parmtype++;
	}
	return head;
}

struct variable *
vardecl(char *name, data_type_t type, storage_class_t sc)
{
	struct variable *var = variable_install(name);

	if (type == dtype_unspecified)
		return NULL;

	if (var->type == dtype_unspecified) {
		/* the variable has just been added: go straight to
		   initializing it */;
	} else if (sc != var->storage_class) {
		struct variable *vp;
		
		switch (sc) {
		case storage_extern:
			parse_error("INTERNAL ERROR at %s:%d, declaring %s %s",
				    __FILE__, __LINE__,
				    storage_class_str(sc), name);
			abort();

		case storage_auto:
			if (var->storage_class == storage_param) {
				parse_error("warning: automatic variable `%s'"
					    "is shadowing a parameter");
			} else
				parse_error("warning: automatic variable `%s'"
					    "is shadowing a global");
			unregister_auto(var);
			break;

		case storage_param:
			parse_error("warning: parameter %s is shadowing a "
				    "global",
				    name);
		}

		/* Do the shadowing */
		vp = emalloc(sizeof *var);
		*vp = *var;
		var->shadowed = vp;
	} else {
		switch (sc) {
		case storage_extern:
		case storage_auto:
			if (var->type != type) {
				parse_error("redeclaring `%s' as different "
					    "data type",
					    name);
				parse_error_locus(&var->locus,
					    "this is the location of the "
						  "previous definition");
				error_count++;
				return NULL;
			}
			break;

		case storage_param:
			parse_error("duplicate parameter: %s", name);
			error_count++;
			return NULL;
		}
	}

	var->type = type;
	var->storage_class = sc;
	switch (sc) {
	case storage_extern:
		var->off = variable_count++;
		break;
	case storage_auto:
		register_auto(var);
		var->off = auto_count++;
		break;
	case storage_param:
		register_auto(var);
		var->off = 1 + param_count++;
		break;
	}
	var->locus = *get_locus();
	return var;
}

struct variable *
externdecl(char *name, data_type_t type, STKVAL val)
{
	struct variable *var = vardecl(name, type, storage_extern);
	if (!var)
		return NULL;
	if (var->type != type) {
		char buf[NUMERIC_BUFSIZE_BOUND];
		char *p;
		
		switch (var->type) {
		default:
			abort();
			
		case dtype_string:
			snprintf(buf, sizeof buf, "%ld", (long) val);
			val = strdup(buf);
			break;

		case dtype_number:
			val = (STKVAL) strtol(val, &p, 10);
			if (*p) {
				parse_error("cannot convert `%s' to number",
					    val);
				return NULL;
			}
			break;
		}
	}
	declare_variable(name, var->off, val);
	return var;
}
			

struct auto_rec {
	struct auto_rec *next;
	struct variable *var;
};

static struct auto_rec *auto_list;

static void
register_auto(struct variable *var)
{
	struct auto_rec *p = emalloc(sizeof *p);
	p->var = var;
	p->next = auto_list;
	auto_list = p;
}

static void
unregister_auto(struct variable *var)
{
	struct auto_rec *p = auto_list, *prev = NULL;
	while (p) {
		struct auto_rec *next = p->next;
		if (p->var == var) {
			if (prev)
				prev->next = next;
			else
				auto_list = next;
			free(p);
			return;
		}
		prev = p;
		p = next;
	}
}

static void
forget_autos()
{
	struct auto_rec *p = auto_list;
	while (p) {
		struct auto_rec *next = p->next;
		struct variable *var = p->var;
		while (var->storage_class != storage_extern) {
			struct variable *shadowed = var->shadowed;
			if (shadowed) {
				*var = *shadowed;
				free(shadowed);
			} else {
				find_and_remove(SYM_VARIABLE,
						var->name);
				break;
			}
		}
		p = next;
	}
}

const char *
storage_class_str(storage_class_t sc)
{
	switch (sc) {
	case storage_extern:
		return "extern";
	case storage_auto:
		return "auto";
	case storage_param:
		return "param";
	}
	return "unknown?";
}


const char *
function_name()
{
	switch (stie_in) {
	case synt_function:
		return func->name;
	case synt_handler:
		return state_to_string(state_tag);
	default:
		return "";
	}
}

